/******/ (() => { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ "./node_modules/@riotjs/observable/dist/observable.js":
/*!************************************************************!*\
  !*** ./node_modules/@riotjs/observable/dist/observable.js ***!
  \************************************************************/
/***/ ((module) => {

;(function(window, undefined) {const ALL_CALLBACKS = '*'
const define = Object.defineProperties
const entries = Object.entries

const on = (callbacks, el) => (event, fn) => {
  if (callbacks.has(event)) {
    callbacks.get(event).add(fn)
  } else {
    callbacks.set(event, new Set().add(fn))
  }

  return el
}

const deleteCallback = (callbacks, el, event,  fn) => {
  if (fn) {
    const fns = callbacks.get(event)

    if (fns) {
      fns.delete(fn)
      if (fns.size === 0) callbacks.delete(event)
    }
  } else callbacks.delete(event)
}

const off = (callbacks, el) => (event, fn) => {
  if (event === ALL_CALLBACKS && !fn) {
    callbacks.clear()
  } else {
    deleteCallback(callbacks, el, event, fn)
  }

  return el
}

const one = (callbacks, el) => (event, fn) => {
  function on(...args) {
    el.off(event, on)
    fn.apply(el, args)
  }
  return el.on(event, on)
}

const trigger = (callbacks, el) => (event, ...args) => {
  const fns = callbacks.get(event)

  if (fns) fns.forEach(fn => fn.apply(el, args))

  if (callbacks.get(ALL_CALLBACKS) && event !== ALL_CALLBACKS) {
    el.trigger(ALL_CALLBACKS, event, ...args)
  }

  return el
}

const observable = function(el) { // eslint-disable-line
  const callbacks = new Map()
  const methods = {on, off, one, trigger}

  el = el || {}

  define(el,
    entries(methods).reduce((acc, [key, method]) => {
      acc[key] = {
        value: method(callbacks, el),
        enumerable: false,
        writable: false,
        configurable: false
      }

      return acc
    }, {})
  )

  return el
}
  /* istanbul ignore next */
  // support CommonJS, AMD & browser
  if (true)
    module.exports = observable
  else {}

})(typeof window != 'undefined' ? window : undefined);

/***/ }),

/***/ "./src/datepicker.riot":
/*!*****************************!*\
  !*** ./src/datepicker.riot ***!
  \*****************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _mixin_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./mixin.js */ "./src/mixin.js");
// mixin


/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ({
  css: null,

  exports: () => {
      return {

          ..._mixin_js__WEBPACK_IMPORTED_MODULE_0__["default"]

      }
  },

  template: (
    template,
    expressionTypes,
    bindingTypes,
    getComponent
  ) => template(
    '<div class="tiny-datepicker"><div class="tiny-datepicker__calendar"><div expr0="expr0" class="tiny-datepicker__date"> </div><div class="tiny-datepicker__days"><div class="tiny-datepicker__week"><div expr1="expr1" class="tiny-datepicker__day tiny-datepicker__day--header"></div></div><div expr2="expr2" class="tiny-datepicker__week"></div></div><div class="tiny-datepicker__select m-top-3 m-bottom-3"><button expr4="expr4" class="button m-bottom-0 tiny-datepicker__button">\n                    &lArr;\n                </button><div class="tiny-datepicker__label m-top-3 m-bottom-3"><select expr5="expr5" class="field-choice"><option expr6="expr6"></option></select></div><button expr7="expr7" class="button m-bottom-0 tiny-datepicker__button">\n                    &rArr;\n                </button></div><div class="tiny-datepicker__select m-top-3 m-bottom-3"><button expr8="expr8" class="button m-bottom-0 tiny-datepicker__button">\n                    &lArr;\n                </button><div class="tiny-datepicker__label"><input expr9="expr9" class="field-text"/></div><button expr10="expr10" class="button m-bottom-0 tiny-datepicker__button">\n                    &rArr;\n                </button></div></div></div>',
    [
      {
        redundantAttribute: 'expr0',
        selector: '[expr0]',

        expressions: [
          {
            type: expressionTypes.TEXT,
            childNodeIndex: 0,

            evaluate: _scope => [
              _scope.state.date.format('dddd, DD. MMMM YYYY')
            ].join(
              ''
            )
          }
        ]
      },
      {
        type: bindingTypes.EACH,
        getKey: null,
        condition: null,

        template: template(
          ' ',
          [
            {
              expressions: [
                {
                  type: expressionTypes.TEXT,
                  childNodeIndex: 0,

                  evaluate: _scope => [
                    _scope.name
                  ].join(
                    ''
                  )
                }
              ]
            }
          ]
        ),

        redundantAttribute: 'expr1',
        selector: '[expr1]',
        itemName: 'name',
        indexName: null,
        evaluate: _scope => _scope.state.weekdaysNames
      },
      {
        type: bindingTypes.EACH,
        getKey: null,
        condition: null,

        template: template(
          '<div expr3="expr3"></div>',
          [
            {
              type: bindingTypes.EACH,
              getKey: null,
              condition: null,

              template: template(
                ' ',
                [
                  {
                    expressions: [
                      {
                        type: expressionTypes.TEXT,
                        childNodeIndex: 0,

                        evaluate: _scope => [
                          _scope.day.date()
                        ].join(
                          ''
                        )
                      },
                      {
                        type: expressionTypes.ATTRIBUTE,
                        name: 'class',
                        evaluate: _scope => _scope.addClassDay(_scope.day, ['tiny-datepicker__day'])
                      },
                      {
                        type: expressionTypes.EVENT,
                        name: 'onclick',
                        evaluate: _scope => (event) => { _scope.handleSelectDay(event, _scope.day) }
                      }
                    ]
                  }
                ]
              ),

              redundantAttribute: 'expr3',
              selector: '[expr3]',
              itemName: 'day',
              indexName: null,
              evaluate: _scope => _scope.week
            }
          ]
        ),

        redundantAttribute: 'expr2',
        selector: '[expr2]',
        itemName: 'week',
        indexName: null,
        evaluate: _scope => _scope.state.weeks
      },
      {
        redundantAttribute: 'expr4',
        selector: '[expr4]',

        expressions: [
          {
            type: expressionTypes.EVENT,
            name: 'onclick',
            evaluate: _scope => () => { _scope.handlePreviousMonth(_scope.event) }
          }
        ]
      },
      {
        redundantAttribute: 'expr5',
        selector: '[expr5]',

        expressions: [
          {
            type: expressionTypes.EVENT,
            name: 'onchange',
            evaluate: _scope => (event) => { _scope.handleSelectMonth(event) }
          }
        ]
      },
      {
        type: bindingTypes.EACH,
        getKey: null,
        condition: null,

        template: template(
          ' ',
          [
            {
              expressions: [
                {
                  type: expressionTypes.TEXT,
                  childNodeIndex: 0,
                  evaluate: _scope => _scope.name
                },
                {
                  type: expressionTypes.ATTRIBUTE,
                  name: 'value',
                  evaluate: _scope => _scope.index
                },
                {
                  type: expressionTypes.ATTRIBUTE,
                  name: 'selected',
                  evaluate: _scope => _scope.state.date.month() === _scope.index
                }
              ]
            }
          ]
        ),

        redundantAttribute: 'expr6',
        selector: '[expr6]',
        itemName: 'name',
        indexName: 'index',
        evaluate: _scope => _scope.state.monthNames
      },
      {
        redundantAttribute: 'expr7',
        selector: '[expr7]',

        expressions: [
          {
            type: expressionTypes.EVENT,
            name: 'onclick',
            evaluate: _scope => () => { _scope.handleNextMonth(_scope.event) }
          }
        ]
      },
      {
        redundantAttribute: 'expr8',
        selector: '[expr8]',

        expressions: [
          {
            type: expressionTypes.EVENT,
            name: 'onclick',
            evaluate: _scope => () => { _scope.handlePreviousYear(_scope.event) }
          }
        ]
      },
      {
        redundantAttribute: 'expr9',
        selector: '[expr9]',

        expressions: [
          {
            type: expressionTypes.VALUE,
            evaluate: _scope => _scope.state.date.format('YYYY')
          },
          {
            type: expressionTypes.EVENT,
            name: 'onkeyup',
            evaluate: _scope => (event) => { _scope.handleSelectYear(event) }
          }
        ]
      },
      {
        redundantAttribute: 'expr10',
        selector: '[expr10]',

        expressions: [
          {
            type: expressionTypes.EVENT,
            name: 'onclick',
            evaluate: _scope => () => { _scope.handleNextYear(_scope.event) }
          }
        ]
      }
    ]
  ),

  name: 'tiny-datepicker'
});

/***/ }),

/***/ "./src/example.js":
/*!************************!*\
  !*** ./src/example.js ***!
  \************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var riot__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! riot */ "./node_modules/riot/esm/api/register.js");
/* harmony import */ var riot__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! riot */ "./node_modules/riot/esm/riot.js");
/* harmony import */ var _datepicker_riot__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./datepicker.riot */ "./src/datepicker.riot");
/* harmony import */ var _store_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./store.js */ "./src/store.js");
/* harmony import */ var dayjs__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! dayjs */ "./node_modules/dayjs/dayjs.min.js");
/* harmony import */ var dayjs__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(dayjs__WEBPACK_IMPORTED_MODULE_3__);



riot__WEBPACK_IMPORTED_MODULE_2__.register('tiny-datepicker', _datepicker_riot__WEBPACK_IMPORTED_MODULE_0__["default"]);

window.riot = riot__WEBPACK_IMPORTED_MODULE_4__;
document.addEventListener("DOMContentLoaded", function (event) {
  var console = document.querySelector('.console');
  _store_js__WEBPACK_IMPORTED_MODULE_1__["default"].on('change', function (data) {
    var element = document.createElement('div');
    element.append('Event => Change, ' + data.date.format('YYYY-MM-DD'));
    console.append(element);
  });
});

/***/ }),

/***/ "./src/mixin.js":
/*!**********************!*\
  !*** ./src/mixin.js ***!
  \**********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var dayjs__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! dayjs */ "./node_modules/dayjs/dayjs.min.js");
/* harmony import */ var dayjs__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(dayjs__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _store_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./store.js */ "./src/store.js");
/* harmony import */ var dayjs_plugin_isoWeek__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! dayjs/plugin/isoWeek */ "./node_modules/dayjs/plugin/isoWeek.js");
/* harmony import */ var dayjs_plugin_isoWeek__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(dayjs_plugin_isoWeek__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var dayjs_plugin_localeData__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! dayjs/plugin/localeData */ "./node_modules/dayjs/plugin/localeData.js");
/* harmony import */ var dayjs_plugin_localeData__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(dayjs_plugin_localeData__WEBPACK_IMPORTED_MODULE_3__);



// add function for iso 

dayjs__WEBPACK_IMPORTED_MODULE_0___default().extend((dayjs_plugin_isoWeek__WEBPACK_IMPORTED_MODULE_2___default()));

// getting local data for names 

dayjs__WEBPACK_IMPORTED_MODULE_0___default().extend((dayjs_plugin_localeData__WEBPACK_IMPORTED_MODULE_3___default()));

/**
 *  Mixin for extends Riot-Component
 *
 *  @author Björn Hase
 *  @license http://opensource.org/licenses/MIT The MIT License
 *  @link https://gitea.node001.net/tiny-components/datepicker
 *
 */

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ({
  state: {
    date: false,
    weeks: [],
    firstDayOfMonth: false,
    firstDayOfWeek: false,
    lastDayOfMonth: false,
    weekdaysNames: [],
    monthNames: [],
    weekFormat: 'isoWeek',
    isoFormat: true
  },
  /**
   *
   *
   */
  onBeforeMount: function onBeforeMount() {
    var _this = this;
    this.state.monthNames = dayjs__WEBPACK_IMPORTED_MODULE_0___default().months();
    this.state.weekdaysNames = dayjs__WEBPACK_IMPORTED_MODULE_0___default().weekdaysShort();
    if (this.props.date) {
      this.state.date = dayjs__WEBPACK_IMPORTED_MODULE_0___default()(this.props.date);
    } else {
      this.state.date = dayjs__WEBPACK_IMPORTED_MODULE_0___default()();
    }

    // change 
    if (this.props.isoFormat === 0) {
      this.state.isoFormat = false;
      this.state.weekFormat = 'week';
    } else {
      this.state.weekdaysNames.push(this.state.weekdaysNames.shift());
    }
    _store_js__WEBPACK_IMPORTED_MODULE_1__["default"].on('update', function (data) {
      _this.state.date = dayjs__WEBPACK_IMPORTED_MODULE_0___default()(data.date);
    });
    this.createWeeksAndDays();
  },
  /**
   *
   *
   */
  onBeforeUpdate: function onBeforeUpdate() {
    _store_js__WEBPACK_IMPORTED_MODULE_1__["default"].trigger('change', {
      date: this.state.date
    });
  },
  /**
   *  create weeks and days
   *
   *
   */
  createWeeksAndDays: function createWeeksAndDays() {
    this.state.weeks = [];

    // getting first day of Month
    this.state.firstDayOfMonth = this.state.date.startOf('month');
    this.state.firstDayOfWeek = this.state.firstDayOfMonth.startOf(this.state.weekFormat);
    this.state.lastDayOfMonth = this.state.date.endOf('month');
    var lastDayOfWeek = this.state.lastDayOfMonth.endOf(this.state.weekFormat).startOf('day');
    var day = this.state.firstDayOfWeek.clone();
    do {
      day = this.fillWeek(day);
    } while (day.isBefore(lastDayOfWeek));
  },
  /**
   *  fill week with days
   *
   *  @param {object} day 
   *
   */
  fillWeek: function fillWeek(day) {
    var days = [];
    days.push(day);
    do {
      day = day.add(1, 'day');
      days.push(day);
    } while (days.length <= 6);
    this.state.weeks.push(days);

    // raise day for start of week
    return day.add(1, 'day');
  },
  /**
   *  select single day
   *
   *  @param {object} event
   *  @param {object} day 
   *
   */
  handleSelectDay: function handleSelectDay(event, day) {
    if (day.isSame(this.state.date)) {
      return false;
    }
    this.state.date = day;
    this.update();
  },
  /**
   *  select month
   *
   *  @param {object} event
   *
   */
  handleSelectMonth: function handleSelectMonth(event) {
    this.state.date = this.state.date.month(event.target.value);
    this.createWeeksAndDays();
    this.update();
  },
  /**
   *  select year
   *
   *  @param {object} event
   *
   */
  handleSelectYear: function handleSelectYear(event) {
    this.state.date = this.state.date.year(event.target.value);
    this.createWeeksAndDays();
    this.update();
  },
  /**
   *  previous month
   *
   *  @param {object} event
   *  @param {object} day 
   *
   */
  handlePreviousMonth: function handlePreviousMonth(event) {
    this.state.date = this.state.date.subtract(1, 'month');
    this.createWeeksAndDays();
    this.update();
  },
  /**
   *  next month 
   *
   *  @param {object} event
   *  @param {object} day 
   *
   */
  handleNextMonth: function handleNextMonth(event) {
    this.state.date = this.state.date.add(1, 'month');
    this.createWeeksAndDays();
    this.update();
  },
  /**
   *  previous year
   *
   *  @param {object} event
   *
   */
  handlePreviousYear: function handlePreviousYear(event) {
    this.state.date = this.state.date.subtract(1, 'year');
    this.createWeeksAndDays();
    this.update();
  },
  /**
   *  next year 
   *
   *  @param {object} event
   *
   */
  handleNextYear: function handleNextYear(event) {
    this.state.date = this.state.date.add(1, 'year');
    this.createWeeksAndDays();
    this.update();
  },
  /**
   *  getting classes for single day 
   *
   *  @param {object} event
   *  @param {array} classes
   *  @return {string}
   */
  addClassDay: function addClassDay(day, classes) {
    if (day.isSame(this.state.date, 'day')) {
      classes.push('tiny-datepicker__day--current');
    }
    if (day.isBefore(this.state.firstDayOfMonth) || day.isAfter(this.state.lastDayOfMonth)) {
      classes.push('tiny-datepicker__day--not-current');
    }
    return classes.join(' ');
  }
});

/***/ }),

/***/ "./src/store.js":
/*!**********************!*\
  !*** ./src/store.js ***!
  \**********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _riotjs_observable__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @riotjs/observable */ "./node_modules/@riotjs/observable/dist/observable.js");
/* harmony import */ var _riotjs_observable__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_riotjs_observable__WEBPACK_IMPORTED_MODULE_0__);


/**
*  store for datepicker
*
*  @author Björn Hase
*  @license http://opensource.org/licenses/MIT The MIT License
*  @link https://gitea.node001.net/tiny-components/confirm
 *
 */

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (_riotjs_observable__WEBPACK_IMPORTED_MODULE_0___default()({}));

/***/ }),

/***/ "./node_modules/dayjs/dayjs.min.js":
/*!*****************************************!*\
  !*** ./node_modules/dayjs/dayjs.min.js ***!
  \*****************************************/
/***/ (function(module) {

!function(t,e){ true?module.exports=e():0}(this,(function(){"use strict";var t=1e3,e=6e4,n=36e5,r="millisecond",i="second",s="minute",u="hour",a="day",o="week",f="month",h="quarter",c="year",d="date",l="Invalid Date",$=/^(\d{4})[-/]?(\d{1,2})?[-/]?(\d{0,2})[Tt\s]*(\d{1,2})?:?(\d{1,2})?:?(\d{1,2})?[.:]?(\d+)?$/,y=/\[([^\]]+)]|Y{1,4}|M{1,4}|D{1,2}|d{1,4}|H{1,2}|h{1,2}|a|A|m{1,2}|s{1,2}|Z{1,2}|SSS/g,M={name:"en",weekdays:"Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),months:"January_February_March_April_May_June_July_August_September_October_November_December".split("_"),ordinal:function(t){var e=["th","st","nd","rd"],n=t%100;return"["+t+(e[(n-20)%10]||e[n]||e[0])+"]"}},m=function(t,e,n){var r=String(t);return!r||r.length>=e?t:""+Array(e+1-r.length).join(n)+t},v={s:m,z:function(t){var e=-t.utcOffset(),n=Math.abs(e),r=Math.floor(n/60),i=n%60;return(e<=0?"+":"-")+m(r,2,"0")+":"+m(i,2,"0")},m:function t(e,n){if(e.date()<n.date())return-t(n,e);var r=12*(n.year()-e.year())+(n.month()-e.month()),i=e.clone().add(r,f),s=n-i<0,u=e.clone().add(r+(s?-1:1),f);return+(-(r+(n-i)/(s?i-u:u-i))||0)},a:function(t){return t<0?Math.ceil(t)||0:Math.floor(t)},p:function(t){return{M:f,y:c,w:o,d:a,D:d,h:u,m:s,s:i,ms:r,Q:h}[t]||String(t||"").toLowerCase().replace(/s$/,"")},u:function(t){return void 0===t}},g="en",D={};D[g]=M;var p=function(t){return t instanceof _},S=function t(e,n,r){var i;if(!e)return g;if("string"==typeof e){var s=e.toLowerCase();D[s]&&(i=s),n&&(D[s]=n,i=s);var u=e.split("-");if(!i&&u.length>1)return t(u[0])}else{var a=e.name;D[a]=e,i=a}return!r&&i&&(g=i),i||!r&&g},w=function(t,e){if(p(t))return t.clone();var n="object"==typeof e?e:{};return n.date=t,n.args=arguments,new _(n)},O=v;O.l=S,O.i=p,O.w=function(t,e){return w(t,{locale:e.$L,utc:e.$u,x:e.$x,$offset:e.$offset})};var _=function(){function M(t){this.$L=S(t.locale,null,!0),this.parse(t)}var m=M.prototype;return m.parse=function(t){this.$d=function(t){var e=t.date,n=t.utc;if(null===e)return new Date(NaN);if(O.u(e))return new Date;if(e instanceof Date)return new Date(e);if("string"==typeof e&&!/Z$/i.test(e)){var r=e.match($);if(r){var i=r[2]-1||0,s=(r[7]||"0").substring(0,3);return n?new Date(Date.UTC(r[1],i,r[3]||1,r[4]||0,r[5]||0,r[6]||0,s)):new Date(r[1],i,r[3]||1,r[4]||0,r[5]||0,r[6]||0,s)}}return new Date(e)}(t),this.$x=t.x||{},this.init()},m.init=function(){var t=this.$d;this.$y=t.getFullYear(),this.$M=t.getMonth(),this.$D=t.getDate(),this.$W=t.getDay(),this.$H=t.getHours(),this.$m=t.getMinutes(),this.$s=t.getSeconds(),this.$ms=t.getMilliseconds()},m.$utils=function(){return O},m.isValid=function(){return!(this.$d.toString()===l)},m.isSame=function(t,e){var n=w(t);return this.startOf(e)<=n&&n<=this.endOf(e)},m.isAfter=function(t,e){return w(t)<this.startOf(e)},m.isBefore=function(t,e){return this.endOf(e)<w(t)},m.$g=function(t,e,n){return O.u(t)?this[e]:this.set(n,t)},m.unix=function(){return Math.floor(this.valueOf()/1e3)},m.valueOf=function(){return this.$d.getTime()},m.startOf=function(t,e){var n=this,r=!!O.u(e)||e,h=O.p(t),l=function(t,e){var i=O.w(n.$u?Date.UTC(n.$y,e,t):new Date(n.$y,e,t),n);return r?i:i.endOf(a)},$=function(t,e){return O.w(n.toDate()[t].apply(n.toDate("s"),(r?[0,0,0,0]:[23,59,59,999]).slice(e)),n)},y=this.$W,M=this.$M,m=this.$D,v="set"+(this.$u?"UTC":"");switch(h){case c:return r?l(1,0):l(31,11);case f:return r?l(1,M):l(0,M+1);case o:var g=this.$locale().weekStart||0,D=(y<g?y+7:y)-g;return l(r?m-D:m+(6-D),M);case a:case d:return $(v+"Hours",0);case u:return $(v+"Minutes",1);case s:return $(v+"Seconds",2);case i:return $(v+"Milliseconds",3);default:return this.clone()}},m.endOf=function(t){return this.startOf(t,!1)},m.$set=function(t,e){var n,o=O.p(t),h="set"+(this.$u?"UTC":""),l=(n={},n[a]=h+"Date",n[d]=h+"Date",n[f]=h+"Month",n[c]=h+"FullYear",n[u]=h+"Hours",n[s]=h+"Minutes",n[i]=h+"Seconds",n[r]=h+"Milliseconds",n)[o],$=o===a?this.$D+(e-this.$W):e;if(o===f||o===c){var y=this.clone().set(d,1);y.$d[l]($),y.init(),this.$d=y.set(d,Math.min(this.$D,y.daysInMonth())).$d}else l&&this.$d[l]($);return this.init(),this},m.set=function(t,e){return this.clone().$set(t,e)},m.get=function(t){return this[O.p(t)]()},m.add=function(r,h){var d,l=this;r=Number(r);var $=O.p(h),y=function(t){var e=w(l);return O.w(e.date(e.date()+Math.round(t*r)),l)};if($===f)return this.set(f,this.$M+r);if($===c)return this.set(c,this.$y+r);if($===a)return y(1);if($===o)return y(7);var M=(d={},d[s]=e,d[u]=n,d[i]=t,d)[$]||1,m=this.$d.getTime()+r*M;return O.w(m,this)},m.subtract=function(t,e){return this.add(-1*t,e)},m.format=function(t){var e=this,n=this.$locale();if(!this.isValid())return n.invalidDate||l;var r=t||"YYYY-MM-DDTHH:mm:ssZ",i=O.z(this),s=this.$H,u=this.$m,a=this.$M,o=n.weekdays,f=n.months,h=function(t,n,i,s){return t&&(t[n]||t(e,r))||i[n].slice(0,s)},c=function(t){return O.s(s%12||12,t,"0")},d=n.meridiem||function(t,e,n){var r=t<12?"AM":"PM";return n?r.toLowerCase():r},$={YY:String(this.$y).slice(-2),YYYY:this.$y,M:a+1,MM:O.s(a+1,2,"0"),MMM:h(n.monthsShort,a,f,3),MMMM:h(f,a),D:this.$D,DD:O.s(this.$D,2,"0"),d:String(this.$W),dd:h(n.weekdaysMin,this.$W,o,2),ddd:h(n.weekdaysShort,this.$W,o,3),dddd:o[this.$W],H:String(s),HH:O.s(s,2,"0"),h:c(1),hh:c(2),a:d(s,u,!0),A:d(s,u,!1),m:String(u),mm:O.s(u,2,"0"),s:String(this.$s),ss:O.s(this.$s,2,"0"),SSS:O.s(this.$ms,3,"0"),Z:i};return r.replace(y,(function(t,e){return e||$[t]||i.replace(":","")}))},m.utcOffset=function(){return 15*-Math.round(this.$d.getTimezoneOffset()/15)},m.diff=function(r,d,l){var $,y=O.p(d),M=w(r),m=(M.utcOffset()-this.utcOffset())*e,v=this-M,g=O.m(this,M);return g=($={},$[c]=g/12,$[f]=g,$[h]=g/3,$[o]=(v-m)/6048e5,$[a]=(v-m)/864e5,$[u]=v/n,$[s]=v/e,$[i]=v/t,$)[y]||v,l?g:O.a(g)},m.daysInMonth=function(){return this.endOf(f).$D},m.$locale=function(){return D[this.$L]},m.locale=function(t,e){if(!t)return this.$L;var n=this.clone(),r=S(t,e,!0);return r&&(n.$L=r),n},m.clone=function(){return O.w(this.$d,this)},m.toDate=function(){return new Date(this.valueOf())},m.toJSON=function(){return this.isValid()?this.toISOString():null},m.toISOString=function(){return this.$d.toISOString()},m.toString=function(){return this.$d.toUTCString()},M}(),T=_.prototype;return w.prototype=T,[["$ms",r],["$s",i],["$m",s],["$H",u],["$W",a],["$M",f],["$y",c],["$D",d]].forEach((function(t){T[t[1]]=function(e){return this.$g(e,t[0],t[1])}})),w.extend=function(t,e){return t.$i||(t(e,_,w),t.$i=!0),w},w.locale=S,w.isDayjs=p,w.unix=function(t){return w(1e3*t)},w.en=D[g],w.Ls=D,w.p={},w}));

/***/ }),

/***/ "./node_modules/dayjs/plugin/isoWeek.js":
/*!**********************************************!*\
  !*** ./node_modules/dayjs/plugin/isoWeek.js ***!
  \**********************************************/
/***/ (function(module) {

!function(e,t){ true?module.exports=t():0}(this,(function(){"use strict";var e="day";return function(t,i,s){var a=function(t){return t.add(4-t.isoWeekday(),e)},d=i.prototype;d.isoWeekYear=function(){return a(this).year()},d.isoWeek=function(t){if(!this.$utils().u(t))return this.add(7*(t-this.isoWeek()),e);var i,d,n,o,r=a(this),u=(i=this.isoWeekYear(),d=this.$u,n=(d?s.utc:s)().year(i).startOf("year"),o=4-n.isoWeekday(),n.isoWeekday()>4&&(o+=7),n.add(o,e));return r.diff(u,"week")+1},d.isoWeekday=function(e){return this.$utils().u(e)?this.day()||7:this.day(this.day()%7?e:e-7)};var n=d.startOf;d.startOf=function(e,t){var i=this.$utils(),s=!!i.u(t)||t;return"isoweek"===i.p(e)?s?this.date(this.date()-(this.isoWeekday()-1)).startOf("day"):this.date(this.date()-1-(this.isoWeekday()-1)+7).endOf("day"):n.bind(this)(e,t)}}}));

/***/ }),

/***/ "./node_modules/dayjs/plugin/localeData.js":
/*!*************************************************!*\
  !*** ./node_modules/dayjs/plugin/localeData.js ***!
  \*************************************************/
/***/ (function(module) {

!function(n,e){ true?module.exports=e():0}(this,(function(){"use strict";return function(n,e,t){var r=e.prototype,o=function(n){return n&&(n.indexOf?n:n.s)},u=function(n,e,t,r,u){var i=n.name?n:n.$locale(),a=o(i[e]),s=o(i[t]),f=a||s.map((function(n){return n.slice(0,r)}));if(!u)return f;var d=i.weekStart;return f.map((function(n,e){return f[(e+(d||0))%7]}))},i=function(){return t.Ls[t.locale()]},a=function(n,e){return n.formats[e]||function(n){return n.replace(/(\[[^\]]+])|(MMMM|MM|DD|dddd)/g,(function(n,e,t){return e||t.slice(1)}))}(n.formats[e.toUpperCase()])},s=function(){var n=this;return{months:function(e){return e?e.format("MMMM"):u(n,"months")},monthsShort:function(e){return e?e.format("MMM"):u(n,"monthsShort","months",3)},firstDayOfWeek:function(){return n.$locale().weekStart||0},weekdays:function(e){return e?e.format("dddd"):u(n,"weekdays")},weekdaysMin:function(e){return e?e.format("dd"):u(n,"weekdaysMin","weekdays",2)},weekdaysShort:function(e){return e?e.format("ddd"):u(n,"weekdaysShort","weekdays",3)},longDateFormat:function(e){return a(n.$locale(),e)},meridiem:this.$locale().meridiem,ordinal:this.$locale().ordinal}};r.localeData=function(){return s.bind(this)()},t.localeData=function(){var n=i();return{firstDayOfWeek:function(){return n.weekStart||0},weekdays:function(){return t.weekdays()},weekdaysShort:function(){return t.weekdaysShort()},weekdaysMin:function(){return t.weekdaysMin()},months:function(){return t.months()},monthsShort:function(){return t.monthsShort()},longDateFormat:function(e){return a(n,e)},meridiem:n.meridiem,ordinal:n.ordinal}},t.months=function(){return u(i(),"months")},t.monthsShort=function(){return u(i(),"monthsShort","months",3)},t.weekdays=function(n){return u(i(),"weekdays",null,null,n)},t.weekdaysShort=function(n){return u(i(),"weekdaysShort","weekdays",3,n)},t.weekdaysMin=function(n){return u(i(),"weekdaysMin","weekdays",2,n)}}}));

/***/ }),

/***/ "./src/example.scss":
/*!**************************!*\
  !*** ./src/example.scss ***!
  \**************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
// extracted by mini-css-extract-plugin


/***/ }),

/***/ "./node_modules/riot/esm/api/__.js":
/*!*****************************************!*\
  !*** ./node_modules/riot/esm/api/__.js ***!
  \*****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "__": () => (/* binding */ __)
/* harmony export */ });
/* harmony import */ var _node_modules_riotjs_util_binding_types_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../node_modules/@riotjs/util/binding-types.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/binding-types.js");
/* harmony import */ var _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../node_modules/@riotjs/util/constants.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/constants.js");
/* harmony import */ var _node_modules_riotjs_util_expression_types_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../node_modules/@riotjs/util/expression-types.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/expression-types.js");
/* harmony import */ var _node_modules_riotjs_dom_bindings_dist_esm_dom_bindings_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../node_modules/@riotjs/dom-bindings/dist/esm.dom-bindings.js */ "./node_modules/riot/esm/node_modules/@riotjs/dom-bindings/dist/esm.dom-bindings.js");
/* harmony import */ var _core_css_manager_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../core/css-manager.js */ "./node_modules/riot/esm/core/css-manager.js");
/* Riot v7.1.0, @license MIT */






// expose some internal stuff that might be used from external tools
const __ = {
  cssManager: _core_css_manager_js__WEBPACK_IMPORTED_MODULE_0__["default"],
  DOMBindings: {
    template: _node_modules_riotjs_dom_bindings_dist_esm_dom_bindings_js__WEBPACK_IMPORTED_MODULE_1__.template,
    createBinding: _node_modules_riotjs_dom_bindings_dist_esm_dom_bindings_js__WEBPACK_IMPORTED_MODULE_1__.createBinding,
    createExpression: _node_modules_riotjs_dom_bindings_dist_esm_dom_bindings_js__WEBPACK_IMPORTED_MODULE_1__.createExpression,
    bindingTypes: _node_modules_riotjs_util_binding_types_js__WEBPACK_IMPORTED_MODULE_2__["default"],
    expressionTypes: _node_modules_riotjs_util_expression_types_js__WEBPACK_IMPORTED_MODULE_3__["default"]
  },
  globals: {
    DOM_COMPONENT_INSTANCE_PROPERTY: _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.DOM_COMPONENT_INSTANCE_PROPERTY,
    PARENT_KEY_SYMBOL: _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.PARENT_KEY_SYMBOL
  }
};




/***/ }),

/***/ "./node_modules/riot/esm/api/component.js":
/*!************************************************!*\
  !*** ./node_modules/riot/esm/api/component.js ***!
  \************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "component": () => (/* binding */ component)
/* harmony export */ });
/* harmony import */ var _node_modules_cumpa_index_next_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../node_modules/cumpa/index.next.js */ "./node_modules/riot/esm/node_modules/cumpa/index.next.js");
/* harmony import */ var _core_create_component_from_wrapper_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../core/create-component-from-wrapper.js */ "./node_modules/riot/esm/core/create-component-from-wrapper.js");
/* Riot v7.1.0, @license MIT */



/**
 * Helper method to create component without relying on the registered ones
 * @param   {Object} implementation - component implementation
 * @returns {Function} function that will allow you to mount a riot component on a DOM node
 */
function component(implementation) {
  return function (el, props, _temp) {
    let {
      slots,
      attributes,
      parentScope
    } = _temp === void 0 ? {} : _temp;
    return (0,_node_modules_cumpa_index_next_js__WEBPACK_IMPORTED_MODULE_0__["default"])(c => c.mount(el, parentScope), c => c({
      props,
      slots,
      attributes
    }), _core_create_component_from_wrapper_js__WEBPACK_IMPORTED_MODULE_1__.createComponentFromWrapper)(implementation);
  };
}




/***/ }),

/***/ "./node_modules/riot/esm/api/install.js":
/*!**********************************************!*\
  !*** ./node_modules/riot/esm/api/install.js ***!
  \**********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "install": () => (/* binding */ install)
/* harmony export */ });
/* harmony import */ var _node_modules_riotjs_util_checks_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../node_modules/@riotjs/util/checks.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/checks.js");
/* harmony import */ var _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../node_modules/@riotjs/util/constants.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/constants.js");
/* harmony import */ var _node_modules_riotjs_util_misc_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../node_modules/@riotjs/util/misc.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/misc.js");
/* Riot v7.1.0, @license MIT */




/**
 * Define a riot plugin
 * @param   {Function} plugin - function that will receive all the components created
 * @returns {Set} the set containing all the plugins installed
 */
function install(plugin) {
  if (!(0,_node_modules_riotjs_util_checks_js__WEBPACK_IMPORTED_MODULE_0__.isFunction)(plugin)) (0,_node_modules_riotjs_util_misc_js__WEBPACK_IMPORTED_MODULE_1__.panic)('Plugins must be of type function');
  if (_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_2__.PLUGINS_SET.has(plugin)) (0,_node_modules_riotjs_util_misc_js__WEBPACK_IMPORTED_MODULE_1__.panic)('This plugin was already installed');
  _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_2__.PLUGINS_SET.add(plugin);
  return _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_2__.PLUGINS_SET;
}




/***/ }),

/***/ "./node_modules/riot/esm/api/mount.js":
/*!********************************************!*\
  !*** ./node_modules/riot/esm/api/mount.js ***!
  \********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "mount": () => (/* binding */ mount)
/* harmony export */ });
/* harmony import */ var _node_modules_bianco_query_index_next_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../node_modules/bianco.query/index.next.js */ "./node_modules/riot/esm/node_modules/bianco.query/index.next.js");
/* harmony import */ var _core_mount_component_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../core/mount-component.js */ "./node_modules/riot/esm/core/mount-component.js");
/* Riot v7.1.0, @license MIT */



/**
 * Mounting function that will work only for the components that were globally registered
 * @param   {string|HTMLElement} selector - query for the selection or a DOM element
 * @param   {Object} initialProps - the initial component properties
 * @param   {string} name - optional component name
 * @returns {Array} list of riot components
 */
function mount(selector, initialProps, name) {
  return (0,_node_modules_bianco_query_index_next_js__WEBPACK_IMPORTED_MODULE_0__["default"])(selector).map(element => (0,_core_mount_component_js__WEBPACK_IMPORTED_MODULE_1__.mountComponent)(element, initialProps, name));
}




/***/ }),

/***/ "./node_modules/riot/esm/api/pure.js":
/*!*******************************************!*\
  !*** ./node_modules/riot/esm/api/pure.js ***!
  \*******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "pure": () => (/* binding */ pure)
/* harmony export */ });
/* harmony import */ var _node_modules_riotjs_util_checks_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../node_modules/@riotjs/util/checks.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/checks.js");
/* harmony import */ var _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../node_modules/@riotjs/util/constants.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/constants.js");
/* harmony import */ var _node_modules_riotjs_util_misc_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../node_modules/@riotjs/util/misc.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/misc.js");
/* Riot v7.1.0, @license MIT */




/**
 * Lift a riot component Interface into a pure riot object
 * @param   {Function} func - RiotPureComponent factory function
 * @returns {Function} the lifted original function received as argument
 */
function pure(func) {
  if (!(0,_node_modules_riotjs_util_checks_js__WEBPACK_IMPORTED_MODULE_0__.isFunction)(func)) (0,_node_modules_riotjs_util_misc_js__WEBPACK_IMPORTED_MODULE_1__.panic)('riot.pure accepts only arguments of type "function"');
  func[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_2__.IS_PURE_SYMBOL] = true;
  return func;
}




/***/ }),

/***/ "./node_modules/riot/esm/api/register.js":
/*!***********************************************!*\
  !*** ./node_modules/riot/esm/api/register.js ***!
  \***********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "register": () => (/* binding */ register)
/* harmony export */ });
/* harmony import */ var _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../node_modules/@riotjs/util/constants.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/constants.js");
/* harmony import */ var _node_modules_riotjs_util_misc_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../node_modules/@riotjs/util/misc.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/misc.js");
/* harmony import */ var _core_create_component_from_wrapper_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../core/create-component-from-wrapper.js */ "./node_modules/riot/esm/core/create-component-from-wrapper.js");
/* Riot v7.1.0, @license MIT */




/**
 * Register a custom tag by name
 * @param   {string} name - component name
 * @param   {Object} implementation - tag implementation
 * @returns {Map} map containing all the components implementations
 */
function register(name, _ref) {
  let {
    css,
    template,
    exports
  } = _ref;
  if (_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__.COMPONENTS_IMPLEMENTATION_MAP.has(name)) (0,_node_modules_riotjs_util_misc_js__WEBPACK_IMPORTED_MODULE_1__.panic)(`The component "${name}" was already registered`);
  _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__.COMPONENTS_IMPLEMENTATION_MAP.set(name, (0,_core_create_component_from_wrapper_js__WEBPACK_IMPORTED_MODULE_2__.createComponentFromWrapper)({
    name,
    css,
    template,
    exports
  }));
  return _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__.COMPONENTS_IMPLEMENTATION_MAP;
}




/***/ }),

/***/ "./node_modules/riot/esm/api/uninstall.js":
/*!************************************************!*\
  !*** ./node_modules/riot/esm/api/uninstall.js ***!
  \************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "uninstall": () => (/* binding */ uninstall)
/* harmony export */ });
/* harmony import */ var _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../node_modules/@riotjs/util/constants.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/constants.js");
/* harmony import */ var _node_modules_riotjs_util_misc_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../node_modules/@riotjs/util/misc.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/misc.js");
/* Riot v7.1.0, @license MIT */



/**
 * Uninstall a riot plugin
 * @param   {Function} plugin - plugin previously installed
 * @returns {Set} the set containing all the plugins installed
 */
function uninstall(plugin) {
  if (!_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__.PLUGINS_SET.has(plugin)) (0,_node_modules_riotjs_util_misc_js__WEBPACK_IMPORTED_MODULE_1__.panic)('This plugin was never installed');
  _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__.PLUGINS_SET["delete"](plugin);
  return _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__.PLUGINS_SET;
}




/***/ }),

/***/ "./node_modules/riot/esm/api/unmount.js":
/*!**********************************************!*\
  !*** ./node_modules/riot/esm/api/unmount.js ***!
  \**********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "unmount": () => (/* binding */ unmount)
/* harmony export */ });
/* harmony import */ var _node_modules_bianco_query_index_next_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../node_modules/bianco.query/index.next.js */ "./node_modules/riot/esm/node_modules/bianco.query/index.next.js");
/* harmony import */ var _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../node_modules/@riotjs/util/constants.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/constants.js");
/* Riot v7.1.0, @license MIT */



/**
 * Sweet unmounting helper function for the DOM node mounted manually by the user
 * @param   {string|HTMLElement} selector - query for the selection or a DOM element
 * @param   {boolean|null} keepRootElement - if true keep the root element
 * @returns {Array} list of nodes unmounted
 */
function unmount(selector, keepRootElement) {
  return (0,_node_modules_bianco_query_index_next_js__WEBPACK_IMPORTED_MODULE_0__["default"])(selector).map(element => {
    if (element[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_1__.DOM_COMPONENT_INSTANCE_PROPERTY]) {
      element[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_1__.DOM_COMPONENT_INSTANCE_PROPERTY].unmount(keepRootElement);
    }
    return element;
  });
}




/***/ }),

/***/ "./node_modules/riot/esm/api/unregister.js":
/*!*************************************************!*\
  !*** ./node_modules/riot/esm/api/unregister.js ***!
  \*************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "unregister": () => (/* binding */ unregister)
/* harmony export */ });
/* harmony import */ var _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../node_modules/@riotjs/util/constants.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/constants.js");
/* harmony import */ var _node_modules_riotjs_util_misc_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../node_modules/@riotjs/util/misc.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/misc.js");
/* harmony import */ var _core_css_manager_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../core/css-manager.js */ "./node_modules/riot/esm/core/css-manager.js");
/* Riot v7.1.0, @license MIT */




/**
 * Unregister a riot web component
 * @param   {string} name - component name
 * @returns {Map} map containing all the components implementations
 */
function unregister(name) {
  if (!_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__.COMPONENTS_IMPLEMENTATION_MAP.has(name)) (0,_node_modules_riotjs_util_misc_js__WEBPACK_IMPORTED_MODULE_1__.panic)(`The component "${name}" was never registered`);
  _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__.COMPONENTS_IMPLEMENTATION_MAP["delete"](name);
  _core_css_manager_js__WEBPACK_IMPORTED_MODULE_2__["default"].remove(name);
  return _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__.COMPONENTS_IMPLEMENTATION_MAP;
}




/***/ }),

/***/ "./node_modules/riot/esm/api/version.js":
/*!**********************************************!*\
  !*** ./node_modules/riot/esm/api/version.js ***!
  \**********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "version": () => (/* binding */ version)
/* harmony export */ });
/* Riot v7.1.0, @license MIT */
/** @type {string} current riot version */
const version = 'v7.1.0';




/***/ }),

/***/ "./node_modules/riot/esm/api/with-types.js":
/*!*************************************************!*\
  !*** ./node_modules/riot/esm/api/with-types.js ***!
  \*************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "withTypes": () => (/* binding */ withTypes)
/* harmony export */ });
/* Riot v7.1.0, @license MIT */
/**
 * no-op function needed to add the proper types to your component via typescript
 * @param {Function|Object} component - component default export
 * @returns {Function|Object} returns exactly what it has received
 */
/* istanbul ignore next */
const withTypes = component => component;




/***/ }),

/***/ "./node_modules/riot/esm/core/add-css-hook.js":
/*!****************************************************!*\
  !*** ./node_modules/riot/esm/core/add-css-hook.js ***!
  \****************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "addCssHook": () => (/* binding */ addCssHook)
/* harmony export */ });
/* harmony import */ var _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../node_modules/@riotjs/util/constants.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/constants.js");
/* harmony import */ var _utils_dom_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../utils/dom.js */ "./node_modules/riot/esm/utils/dom.js");
/* harmony import */ var _node_modules_bianco_attr_index_next_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../node_modules/bianco.attr/index.next.js */ "./node_modules/riot/esm/node_modules/bianco.attr/index.next.js");
/* Riot v7.1.0, @license MIT */




/**
 * Add eventually the "is" attribute to link this DOM node to its css
 * @param {HTMLElement} element - target root node
 * @param {string} name - name of the component mounted
 * @returns {undefined} it's a void function
 */

function addCssHook(element, name) {
  if ((0,_utils_dom_js__WEBPACK_IMPORTED_MODULE_0__.getName)(element) !== name) {
    (0,_node_modules_bianco_attr_index_next_js__WEBPACK_IMPORTED_MODULE_1__.set)(element, _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_2__.IS_DIRECTIVE, name);
  }
}




/***/ }),

/***/ "./node_modules/riot/esm/core/bind-dom-node-to-component-instance.js":
/*!***************************************************************************!*\
  !*** ./node_modules/riot/esm/core/bind-dom-node-to-component-instance.js ***!
  \***************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "bindDOMNodeToComponentInstance": () => (/* binding */ bindDOMNodeToComponentInstance)
/* harmony export */ });
/* harmony import */ var _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../node_modules/@riotjs/util/constants.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/constants.js");
/* Riot v7.1.0, @license MIT */


/**
 * Bind a DOM node to its component object
 * @param   {HTMLElement} node - html node mounted
 * @param   {Object} component - Riot.js component object
 * @returns {Object} the component object received as second argument
 */
const bindDOMNodeToComponentInstance = (node, component) => node[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__.DOM_COMPONENT_INSTANCE_PROPERTY] = component;




/***/ }),

/***/ "./node_modules/riot/esm/core/component-dom-selectors.js":
/*!***************************************************************!*\
  !*** ./node_modules/riot/esm/core/component-dom-selectors.js ***!
  \***************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "COMPONENT_DOM_SELECTORS": () => (/* binding */ COMPONENT_DOM_SELECTORS)
/* harmony export */ });
/* harmony import */ var _node_modules_bianco_query_index_next_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../node_modules/bianco.query/index.next.js */ "./node_modules/riot/esm/node_modules/bianco.query/index.next.js");
/* Riot v7.1.0, @license MIT */


const COMPONENT_DOM_SELECTORS = Object.freeze({
  // component helpers
  $(selector) {
    return (0,_node_modules_bianco_query_index_next_js__WEBPACK_IMPORTED_MODULE_0__["default"])(selector, this.root)[0];
  },
  $$(selector) {
    return (0,_node_modules_bianco_query_index_next_js__WEBPACK_IMPORTED_MODULE_0__["default"])(selector, this.root);
  }
});




/***/ }),

/***/ "./node_modules/riot/esm/core/component-lifecycle-methods.js":
/*!*******************************************************************!*\
  !*** ./node_modules/riot/esm/core/component-lifecycle-methods.js ***!
  \*******************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "COMPONENT_LIFECYCLE_METHODS": () => (/* binding */ COMPONENT_LIFECYCLE_METHODS)
/* harmony export */ });
/* harmony import */ var _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../node_modules/@riotjs/util/constants.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/constants.js");
/* harmony import */ var _node_modules_riotjs_util_functions_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../node_modules/@riotjs/util/functions.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/functions.js");
/* Riot v7.1.0, @license MIT */



const COMPONENT_LIFECYCLE_METHODS = Object.freeze({
  [_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__.SHOULD_UPDATE_KEY]: _node_modules_riotjs_util_functions_js__WEBPACK_IMPORTED_MODULE_1__.noop,
  [_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__.ON_BEFORE_MOUNT_KEY]: _node_modules_riotjs_util_functions_js__WEBPACK_IMPORTED_MODULE_1__.noop,
  [_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__.ON_MOUNTED_KEY]: _node_modules_riotjs_util_functions_js__WEBPACK_IMPORTED_MODULE_1__.noop,
  [_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__.ON_BEFORE_UPDATE_KEY]: _node_modules_riotjs_util_functions_js__WEBPACK_IMPORTED_MODULE_1__.noop,
  [_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__.ON_UPDATED_KEY]: _node_modules_riotjs_util_functions_js__WEBPACK_IMPORTED_MODULE_1__.noop,
  [_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__.ON_BEFORE_UNMOUNT_KEY]: _node_modules_riotjs_util_functions_js__WEBPACK_IMPORTED_MODULE_1__.noop,
  [_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__.ON_UNMOUNTED_KEY]: _node_modules_riotjs_util_functions_js__WEBPACK_IMPORTED_MODULE_1__.noop
});




/***/ }),

/***/ "./node_modules/riot/esm/core/component-template-factory.js":
/*!******************************************************************!*\
  !*** ./node_modules/riot/esm/core/component-template-factory.js ***!
  \******************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "componentTemplateFactory": () => (/* binding */ componentTemplateFactory)
/* harmony export */ });
/* harmony import */ var _node_modules_riotjs_dom_bindings_dist_esm_dom_bindings_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../node_modules/@riotjs/dom-bindings/dist/esm.dom-bindings.js */ "./node_modules/riot/esm/node_modules/@riotjs/dom-bindings/dist/esm.dom-bindings.js");
/* harmony import */ var _node_modules_riotjs_util_expression_types_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../node_modules/@riotjs/util/expression-types.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/expression-types.js");
/* harmony import */ var _node_modules_riotjs_util_binding_types_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../node_modules/@riotjs/util/binding-types.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/binding-types.js");
/* Riot v7.1.0, @license MIT */




/**
 * Factory function to create the component templates only once
 * @param   {Function} template - component template creation function
 * @param   {RiotComponentWrapper} componentWrapper - riot compiler generated object
 * @param   {Function} getChildComponent - getter function to return the children components
 * @returns {TemplateChunk} template chunk object
 */
function componentTemplateFactory(template, componentWrapper, getChildComponent) {
  return template(_node_modules_riotjs_dom_bindings_dist_esm_dom_bindings_js__WEBPACK_IMPORTED_MODULE_0__.template, _node_modules_riotjs_util_expression_types_js__WEBPACK_IMPORTED_MODULE_1__["default"], _node_modules_riotjs_util_binding_types_js__WEBPACK_IMPORTED_MODULE_2__["default"], getChildComponent);
}




/***/ }),

/***/ "./node_modules/riot/esm/core/compute-component-state.js":
/*!***************************************************************!*\
  !*** ./node_modules/riot/esm/core/compute-component-state.js ***!
  \***************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "computeComponentState": () => (/* binding */ computeComponentState)
/* harmony export */ });
/* harmony import */ var _node_modules_riotjs_util_functions_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../node_modules/@riotjs/util/functions.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/functions.js");
/* Riot v7.1.0, @license MIT */


/**
 * Compute the component current state merging it with its previous state
 * @param   {Object} oldState - previous state object
 * @param   {Object} newState - new state given to the `update` call
 * @returns {Object} new object state
 */
function computeComponentState(oldState, newState) {
  return Object.assign({}, oldState, (0,_node_modules_riotjs_util_functions_js__WEBPACK_IMPORTED_MODULE_0__.callOrAssign)(newState));
}




/***/ }),

/***/ "./node_modules/riot/esm/core/compute-initial-props.js":
/*!*************************************************************!*\
  !*** ./node_modules/riot/esm/core/compute-initial-props.js ***!
  \*************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "computeInitialProps": () => (/* binding */ computeInitialProps)
/* harmony export */ });
/* harmony import */ var _node_modules_riotjs_util_dom_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../node_modules/@riotjs/util/dom.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/dom.js");
/* harmony import */ var _node_modules_riotjs_util_functions_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../node_modules/@riotjs/util/functions.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/functions.js");
/* Riot v7.1.0, @license MIT */



/**
 * Evaluate the component properties either from its real attributes or from its initial user properties
 * @param   {HTMLElement} element - component root
 * @param   {Object}  initialProps - initial props
 * @returns {Object} component props key value pairs
 */
function computeInitialProps(element, initialProps) {
  if (initialProps === void 0) {
    initialProps = {};
  }
  return Object.assign({}, (0,_node_modules_riotjs_util_dom_js__WEBPACK_IMPORTED_MODULE_0__.DOMattributesToObject)(element), (0,_node_modules_riotjs_util_functions_js__WEBPACK_IMPORTED_MODULE_1__.callOrAssign)(initialProps));
}




/***/ }),

/***/ "./node_modules/riot/esm/core/create-attribute-bindings.js":
/*!*****************************************************************!*\
  !*** ./node_modules/riot/esm/core/create-attribute-bindings.js ***!
  \*****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "createAttributeBindings": () => (/* binding */ createAttributeBindings)
/* harmony export */ });
/* harmony import */ var _create_core_api_methods_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./create-core-api-methods.js */ "./node_modules/riot/esm/core/create-core-api-methods.js");
/* harmony import */ var _node_modules_riotjs_dom_bindings_dist_esm_dom_bindings_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../node_modules/@riotjs/dom-bindings/dist/esm.dom-bindings.js */ "./node_modules/riot/esm/node_modules/@riotjs/dom-bindings/dist/esm.dom-bindings.js");
/* Riot v7.1.0, @license MIT */



/**
 * Create the bindings to update the component attributes
 * @param   {HTMLElement} node - node where we will bind the expressions
 * @param   {Array} attributes - list of attribute bindings
 * @returns {TemplateChunk} - template bindings object
 */
function createAttributeBindings(node, attributes) {
  if (attributes === void 0) {
    attributes = [];
  }
  const expressions = attributes.map(a => (0,_node_modules_riotjs_dom_bindings_dist_esm_dom_bindings_js__WEBPACK_IMPORTED_MODULE_0__.createExpression)(node, a));
  const binding = {};
  return Object.assign(binding, Object.assign({
    expressions
  }, (0,_create_core_api_methods_js__WEBPACK_IMPORTED_MODULE_1__.createCoreAPIMethods)(method => scope => {
    expressions.forEach(e => e[method](scope));
    return binding;
  })));
}




/***/ }),

/***/ "./node_modules/riot/esm/core/create-component-from-wrapper.js":
/*!*********************************************************************!*\
  !*** ./node_modules/riot/esm/core/create-component-from-wrapper.js ***!
  \*********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "createComponentFromWrapper": () => (/* binding */ createComponentFromWrapper)
/* harmony export */ });
/* harmony import */ var _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../node_modules/@riotjs/util/constants.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/constants.js");
/* harmony import */ var _node_modules_riotjs_util_strings_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../node_modules/@riotjs/util/strings.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/strings.js");
/* harmony import */ var _node_modules_riotjs_util_functions_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../node_modules/@riotjs/util/functions.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/functions.js");
/* harmony import */ var _node_modules_riotjs_util_misc_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../node_modules/@riotjs/util/misc.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/misc.js");
/* harmony import */ var _mocked_template_interface_js__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./mocked-template-interface.js */ "./node_modules/riot/esm/core/mocked-template-interface.js");
/* harmony import */ var _component_template_factory_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./component-template-factory.js */ "./node_modules/riot/esm/core/component-template-factory.js");
/* harmony import */ var _create_pure_component_js__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./create-pure-component.js */ "./node_modules/riot/esm/core/create-pure-component.js");
/* harmony import */ var _instantiate_component_js__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./instantiate-component.js */ "./node_modules/riot/esm/core/instantiate-component.js");
/* Riot v7.1.0, @license MIT */









/**
 * Create the subcomponents that can be included inside a tag in runtime
 * @param   {Object} components - components imported in runtime
 * @returns {Object} all the components transformed into Riot.Component factory functions
 */
function createChildrenComponentsObject(components) {
  if (components === void 0) {
    components = {};
  }
  return Object.entries((0,_node_modules_riotjs_util_functions_js__WEBPACK_IMPORTED_MODULE_0__.callOrAssign)(components)).reduce((acc, _ref) => {
    let [key, value] = _ref;
    acc[(0,_node_modules_riotjs_util_strings_js__WEBPACK_IMPORTED_MODULE_1__.camelToDashCase)(key)] = createComponentFromWrapper(value);
    return acc;
  }, {});
}

/**
 * Create the getter function to render the child components
 * @param   {RiotComponentWrapper} componentWrapper - riot compiler generated object
 * @returns {Function} function returning the component factory function
 */
const createChildComponentGetter = componentWrapper => {
  const childrenComponents = createChildrenComponentsObject(componentWrapper.exports ? componentWrapper.exports.components : {});
  return name => {
    // improve support for recursive components
    if (name === componentWrapper.name) return memoizedCreateComponentFromWrapper(componentWrapper);
    // return the registered components
    return childrenComponents[name] || _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_2__.COMPONENTS_IMPLEMENTATION_MAP.get(name);
  };
};

/**
 * Performance optimization for the recursive components
 * @param  {RiotComponentWrapper} componentWrapper - riot compiler generated object
 * @returns {Object} component like interface
 */
const memoizedCreateComponentFromWrapper = (0,_node_modules_riotjs_util_misc_js__WEBPACK_IMPORTED_MODULE_3__.memoize)(createComponentFromWrapper);

/**
 * Create the component interface needed for the @riotjs/dom-bindings tag bindings
 * @param   {RiotComponentWrapper} componentWrapper - riot compiler generated object
 * @param   {string} componentWrapper.css - component css
 * @param   {Function} componentWrapper.template - function that will return the dom-bindings template function
 * @param   {Object} componentWrapper.exports - component interface
 * @param   {string} componentWrapper.name - component name
 * @returns {Object} component like interface
 */
function createComponentFromWrapper(componentWrapper) {
  const {
    css,
    template,
    exports,
    name
  } = componentWrapper;
  const templateFn = template ? (0,_component_template_factory_js__WEBPACK_IMPORTED_MODULE_4__.componentTemplateFactory)(template, componentWrapper, createChildComponentGetter(componentWrapper)) : _mocked_template_interface_js__WEBPACK_IMPORTED_MODULE_5__.MOCKED_TEMPLATE_INTERFACE;
  return _ref2 => {
    let {
      slots,
      attributes,
      props
    } = _ref2;
    // pure components rendering will be managed by the end user
    if (exports && exports[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_2__.IS_PURE_SYMBOL]) return (0,_create_pure_component_js__WEBPACK_IMPORTED_MODULE_6__.createPureComponent)(exports, {
      slots,
      attributes,
      props,
      css,
      template
    });
    const componentAPI = (0,_node_modules_riotjs_util_functions_js__WEBPACK_IMPORTED_MODULE_0__.callOrAssign)(exports) || {};
    const component = (0,_instantiate_component_js__WEBPACK_IMPORTED_MODULE_7__.instantiateComponent)({
      css,
      template: templateFn,
      componentAPI,
      name
    })({
      slots,
      attributes,
      props
    });

    // notice that for the components created via tag binding
    // we need to invert the mount (state/parentScope) arguments
    // the template bindings will only forward the parentScope updates
    // and never deal with the component state
    return {
      mount(element, parentScope, state) {
        return component.mount(element, state, parentScope);
      },
      update(parentScope, state) {
        return component.update(state, parentScope);
      },
      unmount(preserveRoot) {
        return component.unmount(preserveRoot);
      }
    };
  };
}




/***/ }),

/***/ "./node_modules/riot/esm/core/create-core-api-methods.js":
/*!***************************************************************!*\
  !*** ./node_modules/riot/esm/core/create-core-api-methods.js ***!
  \***************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "createCoreAPIMethods": () => (/* binding */ createCoreAPIMethods)
/* harmony export */ });
/* harmony import */ var _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../node_modules/@riotjs/util/constants.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/constants.js");
/* Riot v7.1.0, @license MIT */


/**
 * Wrap the Riot.js core API methods using a mapping function
 * @param   {Function} mapFunction - lifting function
 * @returns {Object} an object having the { mount, update, unmount } functions
 */
function createCoreAPIMethods(mapFunction) {
  return [_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__.MOUNT_METHOD_KEY, _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__.UPDATE_METHOD_KEY, _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__.UNMOUNT_METHOD_KEY].reduce((acc, method) => {
    acc[method] = mapFunction(method);
    return acc;
  }, {});
}




/***/ }),

/***/ "./node_modules/riot/esm/core/create-pure-component.js":
/*!*************************************************************!*\
  !*** ./node_modules/riot/esm/core/create-pure-component.js ***!
  \*************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "createPureComponent": () => (/* binding */ createPureComponent)
/* harmony export */ });
/* harmony import */ var _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../node_modules/@riotjs/util/constants.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/constants.js");
/* harmony import */ var _node_modules_riotjs_util_misc_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../node_modules/@riotjs/util/misc.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/misc.js");
/* harmony import */ var _node_modules_riotjs_util_objects_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../node_modules/@riotjs/util/objects.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/objects.js");
/* harmony import */ var _pure_component_api_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./pure-component-api.js */ "./node_modules/riot/esm/core/pure-component-api.js");
/* harmony import */ var _bind_dom_node_to_component_instance_js__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./bind-dom-node-to-component-instance.js */ "./node_modules/riot/esm/core/bind-dom-node-to-component-instance.js");
/* harmony import */ var _create_core_api_methods_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./create-core-api-methods.js */ "./node_modules/riot/esm/core/create-core-api-methods.js");
/* Riot v7.1.0, @license MIT */







/**
 * Create a pure component
 * @param   {Function} pureFactoryFunction - pure component factory function
 * @param   {Array} options.slots - component slots
 * @param   {Array} options.attributes - component attributes
 * @param   {Array} options.template - template factory function
 * @param   {Array} options.template - template factory function
 * @param   {any} options.props - initial component properties
 * @returns {Object} pure component object
 */
function createPureComponent(pureFactoryFunction, _ref) {
  let {
    slots,
    attributes,
    props,
    css,
    template
  } = _ref;
  if (template) (0,_node_modules_riotjs_util_misc_js__WEBPACK_IMPORTED_MODULE_0__.panic)('Pure components can not have html');
  if (css) (0,_node_modules_riotjs_util_misc_js__WEBPACK_IMPORTED_MODULE_0__.panic)('Pure components do not have css');
  const component = (0,_node_modules_riotjs_util_objects_js__WEBPACK_IMPORTED_MODULE_1__.defineDefaults)(pureFactoryFunction({
    slots,
    attributes,
    props
  }), _pure_component_api_js__WEBPACK_IMPORTED_MODULE_2__.PURE_COMPONENT_API);
  return (0,_create_core_api_methods_js__WEBPACK_IMPORTED_MODULE_3__.createCoreAPIMethods)(method => function () {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    // intercept the mount calls to bind the DOM node to the pure object created
    // see also https://github.com/riot/riot/issues/2806
    if (method === _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.MOUNT_METHOD_KEY) {
      const [element] = args;
      // mark this node as pure element
      (0,_node_modules_riotjs_util_objects_js__WEBPACK_IMPORTED_MODULE_1__.defineProperty)(element, _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.IS_PURE_SYMBOL, true);
      (0,_bind_dom_node_to_component_instance_js__WEBPACK_IMPORTED_MODULE_5__.bindDOMNodeToComponentInstance)(element, component);
    }
    component[method](...args);
    return component;
  });
}




/***/ }),

/***/ "./node_modules/riot/esm/core/css-manager.js":
/*!***************************************************!*\
  !*** ./node_modules/riot/esm/core/css-manager.js ***!
  \***************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "CSS_BY_NAME": () => (/* binding */ CSS_BY_NAME),
/* harmony export */   "STYLE_NODE_SELECTOR": () => (/* binding */ STYLE_NODE_SELECTOR),
/* harmony export */   "default": () => (/* binding */ cssManager)
/* harmony export */ });
/* harmony import */ var _node_modules_bianco_query_index_next_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../node_modules/bianco.query/index.next.js */ "./node_modules/riot/esm/node_modules/bianco.query/index.next.js");
/* harmony import */ var _node_modules_bianco_attr_index_next_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../node_modules/bianco.attr/index.next.js */ "./node_modules/riot/esm/node_modules/bianco.attr/index.next.js");
/* Riot v7.1.0, @license MIT */



const CSS_BY_NAME = new Map();
const STYLE_NODE_SELECTOR = 'style[riot]';

// memoized curried function
const getStyleNode = (style => {
  return () => {
    // lazy evaluation:
    // if this function was already called before
    // we return its cached result
    if (style) return style;

    // create a new style element or use an existing one
    // and cache it internally
    style = (0,_node_modules_bianco_query_index_next_js__WEBPACK_IMPORTED_MODULE_0__["default"])(STYLE_NODE_SELECTOR)[0] || document.createElement('style');
    (0,_node_modules_bianco_attr_index_next_js__WEBPACK_IMPORTED_MODULE_1__.set)(style, 'type', 'text/css');

    /* istanbul ignore next */
    if (!style.parentNode) document.head.appendChild(style);
    return style;
  };
})();

/**
 * Object that will be used to inject and manage the css of every tag instance
 */
const cssManager = {
  CSS_BY_NAME,
  /**
   * Save a tag style to be later injected into DOM
   * @param { string } name - if it's passed we will map the css to a tagname
   * @param { string } css - css string
   * @returns {Object} self
   */
  add(name, css) {
    if (!CSS_BY_NAME.has(name)) {
      CSS_BY_NAME.set(name, css);
      this.inject();
    }
    return this;
  },
  /**
   * Inject all previously saved tag styles into DOM
   * innerHTML seems slow: http://jsperf.com/riot-insert-style
   * @returns {Object} self
   */
  inject() {
    getStyleNode().innerHTML = [...CSS_BY_NAME.values()].join('\n');
    return this;
  },
  /**
   * Remove a tag style from the DOM
   * @param {string} name a registered tagname
   * @returns {Object} self
   */
  remove(name) {
    if (CSS_BY_NAME.has(name)) {
      CSS_BY_NAME.delete(name);
      this.inject();
    }
    return this;
  }
};




/***/ }),

/***/ "./node_modules/riot/esm/core/instantiate-component.js":
/*!*************************************************************!*\
  !*** ./node_modules/riot/esm/core/instantiate-component.js ***!
  \*************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "instantiateComponent": () => (/* binding */ instantiateComponent)
/* harmony export */ });
/* harmony import */ var _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../node_modules/@riotjs/util/constants.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/constants.js");
/* harmony import */ var _node_modules_riotjs_util_objects_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../node_modules/@riotjs/util/objects.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/objects.js");
/* harmony import */ var _component_dom_selectors_js__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./component-dom-selectors.js */ "./node_modules/riot/esm/core/component-dom-selectors.js");
/* harmony import */ var _component_lifecycle_methods_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./component-lifecycle-methods.js */ "./node_modules/riot/esm/core/component-lifecycle-methods.js");
/* harmony import */ var _css_manager_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./css-manager.js */ "./node_modules/riot/esm/core/css-manager.js");
/* harmony import */ var _node_modules_curri_index_next_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../node_modules/curri/index.next.js */ "./node_modules/riot/esm/node_modules/curri/index.next.js");
/* harmony import */ var _manage_component_lifecycle_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./manage-component-lifecycle.js */ "./node_modules/riot/esm/core/manage-component-lifecycle.js");
/* Riot v7.1.0, @license MIT */








/**
 * Component definition function
 * @param   {Object} implementation - the component implementation will be generated via compiler
 * @param   {Object} component - the component initial properties
 * @returns {Object} a new component implementation object
 */
function instantiateComponent(_ref) {
  let {
    css,
    template,
    componentAPI,
    name
  } = _ref;
  // add the component css into the DOM
  if (css && name) _css_manager_js__WEBPACK_IMPORTED_MODULE_0__["default"].add(name, css);
  return (0,_node_modules_curri_index_next_js__WEBPACK_IMPORTED_MODULE_1__["default"])(_manage_component_lifecycle_js__WEBPACK_IMPORTED_MODULE_2__.manageComponentLifecycle)((0,_node_modules_riotjs_util_objects_js__WEBPACK_IMPORTED_MODULE_3__.defineProperties)(
  // set the component defaults without overriding the original component API
  (0,_node_modules_riotjs_util_objects_js__WEBPACK_IMPORTED_MODULE_3__.defineDefaults)(componentAPI, Object.assign({}, _component_lifecycle_methods_js__WEBPACK_IMPORTED_MODULE_4__.COMPONENT_LIFECYCLE_METHODS, {
    [_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_5__.PROPS_KEY]: {},
    [_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_5__.STATE_KEY]: {}
  })), Object.assign({
    // defined during the component creation
    [_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_5__.SLOTS_KEY]: null,
    [_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_5__.ROOT_KEY]: null
  }, _component_dom_selectors_js__WEBPACK_IMPORTED_MODULE_6__.COMPONENT_DOM_SELECTORS, {
    name,
    css,
    template
  })));
}




/***/ }),

/***/ "./node_modules/riot/esm/core/manage-component-lifecycle.js":
/*!******************************************************************!*\
  !*** ./node_modules/riot/esm/core/manage-component-lifecycle.js ***!
  \******************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "manageComponentLifecycle": () => (/* binding */ manageComponentLifecycle)
/* harmony export */ });
/* harmony import */ var _node_modules_riotjs_util_checks_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../node_modules/@riotjs/util/checks.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/checks.js");
/* harmony import */ var _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../node_modules/@riotjs/util/constants.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/constants.js");
/* harmony import */ var _node_modules_riotjs_util_functions_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../node_modules/@riotjs/util/functions.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/functions.js");
/* harmony import */ var _node_modules_riotjs_util_misc_js__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ../node_modules/@riotjs/util/misc.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/misc.js");
/* harmony import */ var _node_modules_riotjs_util_objects_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../node_modules/@riotjs/util/objects.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/objects.js");
/* harmony import */ var _add_css_hook_js__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./add-css-hook.js */ "./node_modules/riot/esm/core/add-css-hook.js");
/* harmony import */ var _bind_dom_node_to_component_instance_js__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./bind-dom-node-to-component-instance.js */ "./node_modules/riot/esm/core/bind-dom-node-to-component-instance.js");
/* harmony import */ var _compute_component_state_js__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./compute-component-state.js */ "./node_modules/riot/esm/core/compute-component-state.js");
/* harmony import */ var _compute_initial_props_js__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./compute-initial-props.js */ "./node_modules/riot/esm/core/compute-initial-props.js");
/* harmony import */ var _create_attribute_bindings_js__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./create-attribute-bindings.js */ "./node_modules/riot/esm/core/create-attribute-bindings.js");
/* harmony import */ var _run_plugins_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./run-plugins.js */ "./node_modules/riot/esm/core/run-plugins.js");
/* Riot v7.1.0, @license MIT */












/**
 * Component creation factory function that will enhance the user provided API
 * @param   {Object} component - a component implementation previously defined
 * @param   {Array} options.slots - component slots generated via riot compiler
 * @param   {Array} options.attributes - attribute expressions generated via riot compiler
 * @returns {Riot.Component} a riot component instance
 */
function manageComponentLifecycle(component, _ref) {
  let {
    slots,
    attributes,
    props
  } = _ref;
  return (0,_node_modules_riotjs_util_functions_js__WEBPACK_IMPORTED_MODULE_0__.autobindMethods)((0,_run_plugins_js__WEBPACK_IMPORTED_MODULE_1__.runPlugins)((0,_node_modules_riotjs_util_objects_js__WEBPACK_IMPORTED_MODULE_2__.defineProperties)((0,_node_modules_riotjs_util_checks_js__WEBPACK_IMPORTED_MODULE_3__.isObject)(component) ? Object.create(component) : component, {
    mount(element, state, parentScope) {
      if (state === void 0) {
        state = {};
      }
      // any element mounted passing through this function can't be a pure component
      (0,_node_modules_riotjs_util_objects_js__WEBPACK_IMPORTED_MODULE_2__.defineProperty)(element, _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.IS_PURE_SYMBOL, false);
      this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.PARENT_KEY_SYMBOL] = parentScope;
      this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.ATTRIBUTES_KEY_SYMBOL] = (0,_create_attribute_bindings_js__WEBPACK_IMPORTED_MODULE_5__.createAttributeBindings)(element, attributes).mount(parentScope);
      (0,_node_modules_riotjs_util_objects_js__WEBPACK_IMPORTED_MODULE_2__.defineProperty)(this, _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.PROPS_KEY, Object.freeze(Object.assign({}, (0,_compute_initial_props_js__WEBPACK_IMPORTED_MODULE_6__.computeInitialProps)(element, props), (0,_node_modules_riotjs_util_misc_js__WEBPACK_IMPORTED_MODULE_7__.evaluateAttributeExpressions)(this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.ATTRIBUTES_KEY_SYMBOL].expressions))));
      this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.STATE_KEY] = (0,_compute_component_state_js__WEBPACK_IMPORTED_MODULE_8__.computeComponentState)(this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.STATE_KEY], state);
      this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.TEMPLATE_KEY_SYMBOL] = this.template.createDOM(element).clone();

      // link this object to the DOM node
      (0,_bind_dom_node_to_component_instance_js__WEBPACK_IMPORTED_MODULE_9__.bindDOMNodeToComponentInstance)(element, this);
      // add eventually the 'is' attribute
      component.name && (0,_add_css_hook_js__WEBPACK_IMPORTED_MODULE_10__.addCssHook)(element, component.name);

      // define the root element
      (0,_node_modules_riotjs_util_objects_js__WEBPACK_IMPORTED_MODULE_2__.defineProperty)(this, _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.ROOT_KEY, element);
      // define the slots array
      (0,_node_modules_riotjs_util_objects_js__WEBPACK_IMPORTED_MODULE_2__.defineProperty)(this, _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.SLOTS_KEY, slots);

      // before mount lifecycle event
      this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.ON_BEFORE_MOUNT_KEY](this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.PROPS_KEY], this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.STATE_KEY]);
      // mount the template
      this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.TEMPLATE_KEY_SYMBOL].mount(element, this, parentScope);
      this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.ON_MOUNTED_KEY](this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.PROPS_KEY], this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.STATE_KEY]);
      return this;
    },
    update(state, parentScope) {
      if (state === void 0) {
        state = {};
      }
      if (parentScope) {
        this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.PARENT_KEY_SYMBOL] = parentScope;
        this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.ATTRIBUTES_KEY_SYMBOL].update(parentScope);
      }
      const newProps = (0,_node_modules_riotjs_util_misc_js__WEBPACK_IMPORTED_MODULE_7__.evaluateAttributeExpressions)(this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.ATTRIBUTES_KEY_SYMBOL].expressions);
      if (this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.SHOULD_UPDATE_KEY](newProps, this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.PROPS_KEY]) === false) return;
      (0,_node_modules_riotjs_util_objects_js__WEBPACK_IMPORTED_MODULE_2__.defineProperty)(this, _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.PROPS_KEY, Object.freeze(Object.assign({}, this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.PROPS_KEY], newProps)));
      this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.STATE_KEY] = (0,_compute_component_state_js__WEBPACK_IMPORTED_MODULE_8__.computeComponentState)(this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.STATE_KEY], state);
      this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.ON_BEFORE_UPDATE_KEY](this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.PROPS_KEY], this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.STATE_KEY]);

      // avoiding recursive updates
      // see also https://github.com/riot/riot/issues/2895
      if (!this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.IS_COMPONENT_UPDATING]) {
        this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.IS_COMPONENT_UPDATING] = true;
        this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.TEMPLATE_KEY_SYMBOL].update(this, this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.PARENT_KEY_SYMBOL]);
      }
      this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.ON_UPDATED_KEY](this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.PROPS_KEY], this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.STATE_KEY]);
      this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.IS_COMPONENT_UPDATING] = false;
      return this;
    },
    unmount(preserveRoot) {
      this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.ON_BEFORE_UNMOUNT_KEY](this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.PROPS_KEY], this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.STATE_KEY]);
      this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.ATTRIBUTES_KEY_SYMBOL].unmount();
      // if the preserveRoot is null the template html will be left untouched
      // in that case the DOM cleanup will happen differently from a parent node
      this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.TEMPLATE_KEY_SYMBOL].unmount(this, this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.PARENT_KEY_SYMBOL], preserveRoot === null ? null : !preserveRoot);
      this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.ON_UNMOUNTED_KEY](this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.PROPS_KEY], this[_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_4__.STATE_KEY]);
      return this;
    }
  })), Object.keys(component).filter(prop => (0,_node_modules_riotjs_util_checks_js__WEBPACK_IMPORTED_MODULE_3__.isFunction)(component[prop])));
}




/***/ }),

/***/ "./node_modules/riot/esm/core/mocked-template-interface.js":
/*!*****************************************************************!*\
  !*** ./node_modules/riot/esm/core/mocked-template-interface.js ***!
  \*****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "MOCKED_TEMPLATE_INTERFACE": () => (/* binding */ MOCKED_TEMPLATE_INTERFACE)
/* harmony export */ });
/* harmony import */ var _pure_component_api_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./pure-component-api.js */ "./node_modules/riot/esm/core/pure-component-api.js");
/* harmony import */ var _node_modules_riotjs_util_functions_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../node_modules/@riotjs/util/functions.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/functions.js");
/* Riot v7.1.0, @license MIT */



const MOCKED_TEMPLATE_INTERFACE = Object.assign({}, _pure_component_api_js__WEBPACK_IMPORTED_MODULE_0__.PURE_COMPONENT_API, {
  clone: _node_modules_riotjs_util_functions_js__WEBPACK_IMPORTED_MODULE_1__.noop,
  createDOM: _node_modules_riotjs_util_functions_js__WEBPACK_IMPORTED_MODULE_1__.noop
});




/***/ }),

/***/ "./node_modules/riot/esm/core/mount-component.js":
/*!*******************************************************!*\
  !*** ./node_modules/riot/esm/core/mount-component.js ***!
  \*******************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "mountComponent": () => (/* binding */ mountComponent)
/* harmony export */ });
/* harmony import */ var _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../node_modules/@riotjs/util/constants.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/constants.js");
/* harmony import */ var _node_modules_riotjs_util_misc_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../node_modules/@riotjs/util/misc.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/misc.js");
/* harmony import */ var _utils_dom_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../utils/dom.js */ "./node_modules/riot/esm/utils/dom.js");
/* Riot v7.1.0, @license MIT */




/**
 * Component initialization function starting from a DOM node
 * @param   {HTMLElement} element - element to upgrade
 * @param   {Object} initialProps - initial component properties
 * @param   {string} componentName - component id
 * @param   {Array} slots - component slots
 * @returns {Object} a new component instance bound to a DOM node
 */
function mountComponent(element, initialProps, componentName, slots) {
  const name = componentName || (0,_utils_dom_js__WEBPACK_IMPORTED_MODULE_0__.getName)(element);
  if (!_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_1__.COMPONENTS_IMPLEMENTATION_MAP.has(name)) (0,_node_modules_riotjs_util_misc_js__WEBPACK_IMPORTED_MODULE_2__.panic)(`The component named "${name}" was never registered`);
  const component = _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_1__.COMPONENTS_IMPLEMENTATION_MAP.get(name)({
    props: initialProps,
    slots
  });
  return component.mount(element);
}




/***/ }),

/***/ "./node_modules/riot/esm/core/pure-component-api.js":
/*!**********************************************************!*\
  !*** ./node_modules/riot/esm/core/pure-component-api.js ***!
  \**********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "PURE_COMPONENT_API": () => (/* binding */ PURE_COMPONENT_API)
/* harmony export */ });
/* harmony import */ var _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../node_modules/@riotjs/util/constants.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/constants.js");
/* harmony import */ var _node_modules_riotjs_util_functions_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../node_modules/@riotjs/util/functions.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/functions.js");
/* Riot v7.1.0, @license MIT */



const PURE_COMPONENT_API = Object.freeze({
  [_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__.MOUNT_METHOD_KEY]: _node_modules_riotjs_util_functions_js__WEBPACK_IMPORTED_MODULE_1__.noop,
  [_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__.UPDATE_METHOD_KEY]: _node_modules_riotjs_util_functions_js__WEBPACK_IMPORTED_MODULE_1__.noop,
  [_node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__.UNMOUNT_METHOD_KEY]: _node_modules_riotjs_util_functions_js__WEBPACK_IMPORTED_MODULE_1__.noop
});




/***/ }),

/***/ "./node_modules/riot/esm/core/run-plugins.js":
/*!***************************************************!*\
  !*** ./node_modules/riot/esm/core/run-plugins.js ***!
  \***************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "runPlugins": () => (/* binding */ runPlugins)
/* harmony export */ });
/* harmony import */ var _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../node_modules/@riotjs/util/constants.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/constants.js");
/* Riot v7.1.0, @license MIT */


/**
 * Run the component instance through all the plugins set by the user
 * @param   {Object} component - component instance
 * @returns {Object} the component enhanced by the plugins
 */
function runPlugins(component) {
  return [..._node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_0__.PLUGINS_SET].reduce((c, fn) => fn(c) || c, component);
}




/***/ }),

/***/ "./node_modules/riot/esm/node_modules/@riotjs/dom-bindings/dist/esm.dom-bindings.js":
/*!******************************************************************************************!*\
  !*** ./node_modules/riot/esm/node_modules/@riotjs/dom-bindings/dist/esm.dom-bindings.js ***!
  \******************************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "bindingTypes": () => (/* reexport safe */ _util_binding_types_js__WEBPACK_IMPORTED_MODULE_0__["default"]),
/* harmony export */   "createBinding": () => (/* binding */ create$1),
/* harmony export */   "createExpression": () => (/* binding */ create$4),
/* harmony export */   "expressionTypes": () => (/* reexport safe */ _util_expression_types_js__WEBPACK_IMPORTED_MODULE_1__["default"]),
/* harmony export */   "template": () => (/* binding */ create)
/* harmony export */ });
/* harmony import */ var _util_dom_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../../util/dom.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/dom.js");
/* harmony import */ var _util_constants_js__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ../../util/constants.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/constants.js");
/* harmony import */ var _util_binding_types_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../../util/binding-types.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/binding-types.js");
/* harmony import */ var _util_expression_types_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../../util/expression-types.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/expression-types.js");
/* harmony import */ var _util_objects_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../../util/objects.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/objects.js");
/* harmony import */ var _util_checks_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../../util/checks.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/checks.js");
/* harmony import */ var _util_misc_js__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../../util/misc.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/misc.js");
/* Riot WIP, @license MIT */










const HEAD_SYMBOL = Symbol();
const TAIL_SYMBOL = Symbol();

/**
 * Create the <template> fragments text nodes
 * @return {Object} {{head: Text, tail: Text}}
 */
function createHeadTailPlaceholders() {
  const head = document.createTextNode('');
  const tail = document.createTextNode('');
  head[HEAD_SYMBOL] = true;
  tail[TAIL_SYMBOL] = true;
  return {
    head,
    tail
  };
}

/**
 * Create the template meta object in case of <template> fragments
 * @param   {TemplateChunk} componentTemplate - template chunk object
 * @returns {Object} the meta property that will be passed to the mount function of the TemplateChunk
 */
function createTemplateMeta(componentTemplate) {
  const fragment = componentTemplate.dom.cloneNode(true);
  const {
    head,
    tail
  } = createHeadTailPlaceholders();
  return {
    avoidDOMInjection: true,
    fragment,
    head,
    tail,
    children: [head, ...Array.from(fragment.childNodes), tail]
  };
}

/**
 * ISC License
 *
 * Copyright (c) 2020, Andrea Giammarchi, @WebReflection
 *
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
 * REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
 * INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
 * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */

// fork of https://github.com/WebReflection/udomdiff version 1.1.0
// due to https://github.com/WebReflection/udomdiff/pull/2
/* eslint-disable */

/**
 * @param {Node[]} a The list of current/live children
 * @param {Node[]} b The list of future children
 * @param {(entry: Node, action: number) => Node} get
 * The callback invoked per each entry related DOM operation.
 * @param {Node} [before] The optional node used as anchor to insert before.
 * @returns {Node[]} The same list of future children.
 */
const udomdiff = (a, b, get, before) => {
  const bLength = b.length;
  let aEnd = a.length;
  let bEnd = bLength;
  let aStart = 0;
  let bStart = 0;
  let map = null;
  while (aStart < aEnd || bStart < bEnd) {
    // append head, tail, or nodes in between: fast path
    if (aEnd === aStart) {
      // we could be in a situation where the rest of nodes that
      // need to be added are not at the end, and in such case
      // the node to `insertBefore`, if the index is more than 0
      // must be retrieved, otherwise it's gonna be the first item.
      const node = bEnd < bLength ? bStart ? get(b[bStart - 1], -0).nextSibling : get(b[bEnd - bStart], 0) : before;
      while (bStart < bEnd) (0,_util_dom_js__WEBPACK_IMPORTED_MODULE_2__.insertBefore)(get(b[bStart++], 1), node);
    }
    // remove head or tail: fast path
    else if (bEnd === bStart) {
      while (aStart < aEnd) {
        // remove the node only if it's unknown or not live
        if (!map || !map.has(a[aStart])) (0,_util_dom_js__WEBPACK_IMPORTED_MODULE_2__.removeChild)(get(a[aStart], -1));
        aStart++;
      }
    }
    // same node: fast path
    else if (a[aStart] === b[bStart]) {
      aStart++;
      bStart++;
    }
    // same tail: fast path
    else if (a[aEnd - 1] === b[bEnd - 1]) {
      aEnd--;
      bEnd--;
    }
    // The once here single last swap "fast path" has been removed in v1.1.0
    // https://github.com/WebReflection/udomdiff/blob/single-final-swap/esm/index.js#L69-L85
    // reverse swap: also fast path
    else if (a[aStart] === b[bEnd - 1] && b[bStart] === a[aEnd - 1]) {
      // this is a "shrink" operation that could happen in these cases:
      // [1, 2, 3, 4, 5]
      // [1, 4, 3, 2, 5]
      // or asymmetric too
      // [1, 2, 3, 4, 5]
      // [1, 2, 3, 5, 6, 4]
      const node = get(a[--aEnd], -1).nextSibling;
      (0,_util_dom_js__WEBPACK_IMPORTED_MODULE_2__.insertBefore)(get(b[bStart++], 1), get(a[aStart++], -1).nextSibling);
      (0,_util_dom_js__WEBPACK_IMPORTED_MODULE_2__.insertBefore)(get(b[--bEnd], 1), node);
      // mark the future index as identical (yeah, it's dirty, but cheap 👍)
      // The main reason to do this, is that when a[aEnd] will be reached,
      // the loop will likely be on the fast path, as identical to b[bEnd].
      // In the best case scenario, the next loop will skip the tail,
      // but in the worst one, this node will be considered as already
      // processed, bailing out pretty quickly from the map index check
      a[aEnd] = b[bEnd];
    }
    // map based fallback, "slow" path
    else {
      // the map requires an O(bEnd - bStart) operation once
      // to store all future nodes indexes for later purposes.
      // In the worst case scenario, this is a full O(N) cost,
      // and such scenario happens at least when all nodes are different,
      // but also if both first and last items of the lists are different
      if (!map) {
        map = new Map();
        let i = bStart;
        while (i < bEnd) map.set(b[i], i++);
      }
      // if it's a future node, hence it needs some handling
      if (map.has(a[aStart])) {
        // grab the index of such node, 'cause it might have been processed
        const index = map.get(a[aStart]);
        // if it's not already processed, look on demand for the next LCS
        if (bStart < index && index < bEnd) {
          let i = aStart;
          // counts the amount of nodes that are the same in the future
          let sequence = 1;
          while (++i < aEnd && i < bEnd && map.get(a[i]) === index + sequence) sequence++;
          // effort decision here: if the sequence is longer than replaces
          // needed to reach such sequence, which would brings again this loop
          // to the fast path, prepend the difference before a sequence,
          // and move only the future list index forward, so that aStart
          // and bStart will be aligned again, hence on the fast path.
          // An example considering aStart and bStart are both 0:
          // a: [1, 2, 3, 4]
          // b: [7, 1, 2, 3, 6]
          // this would place 7 before 1 and, from that time on, 1, 2, and 3
          // will be processed at zero cost
          if (sequence > index - bStart) {
            const node = get(a[aStart], 0);
            while (bStart < index) (0,_util_dom_js__WEBPACK_IMPORTED_MODULE_2__.insertBefore)(get(b[bStart++], 1), node);
          }
          // if the effort wasn't good enough, fallback to a replace,
          // moving both source and target indexes forward, hoping that some
          // similar node will be found later on, to go back to the fast path
          else {
            (0,_util_dom_js__WEBPACK_IMPORTED_MODULE_2__.replaceChild)(get(b[bStart++], 1), get(a[aStart++], -1));
          }
        }
        // otherwise move the source forward, 'cause there's nothing to do
        else aStart++;
      }
      // this node has no meaning in the future list, so it's more than safe
      // to remove it, and check the next live node out instead, meaning
      // that only the live list index should be forwarded
      else (0,_util_dom_js__WEBPACK_IMPORTED_MODULE_2__.removeChild)(get(a[aStart++], -1));
    }
  }
  return b;
};
const UNMOUNT_SCOPE = Symbol('unmount');
const EachBinding = {
  // dynamic binding properties
  // childrenMap: null,
  // node: null,
  // root: null,
  // condition: null,
  // evaluate: null,
  // template: null,
  // isTemplateTag: false,
  nodes: [],
  // getKey: null,
  // indexName: null,
  // itemName: null,
  // afterPlaceholder: null,
  // placeholder: null,

  // API methods
  mount(scope, parentScope) {
    return this.update(scope, parentScope);
  },
  update(scope, parentScope) {
    const {
      placeholder,
      nodes,
      childrenMap
    } = this;
    const collection = scope === UNMOUNT_SCOPE ? null : this.evaluate(scope);
    const items = collection ? Array.from(collection) : [];

    // prepare the diffing
    const {
      newChildrenMap,
      batches,
      futureNodes
    } = createPatch(items, scope, parentScope, this);

    // patch the DOM only if there are new nodes
    udomdiff(nodes, futureNodes, patch(Array.from(childrenMap.values()), parentScope), placeholder);

    // trigger the mounts and the updates
    batches.forEach(fn => fn());

    // update the children map
    this.childrenMap = newChildrenMap;
    this.nodes = futureNodes;
    return this;
  },
  unmount(scope, parentScope) {
    this.update(UNMOUNT_SCOPE, parentScope);
    return this;
  }
};

/**
 * Patch the DOM while diffing
 * @param   {any[]} redundant - list of all the children (template, nodes, context) added via each
 * @param   {*} parentScope - scope of the parent template
 * @returns {Function} patch function used by domdiff
 */
function patch(redundant, parentScope) {
  return (item, info) => {
    if (info < 0) {
      // get the last element added to the childrenMap saved previously
      const element = redundant[redundant.length - 1];
      if (element) {
        // get the nodes and the template in stored in the last child of the childrenMap
        const {
          template,
          nodes,
          context
        } = element;
        // remove the last node (notice <template> tags might have more children nodes)
        nodes.pop();

        // notice that we pass null as last argument because
        // the root node and its children will be removed by domdiff
        if (!nodes.length) {
          // we have cleared all the children nodes and we can unmount this template
          redundant.pop();
          template.unmount(context, parentScope, null);
        }
      }
    }
    return item;
  };
}

/**
 * Check whether a template must be filtered from a loop
 * @param   {Function} condition - filter function
 * @param   {Object} context - argument passed to the filter function
 * @returns {boolean} true if this item should be skipped
 */
function mustFilterItem(condition, context) {
  return condition ? !condition(context) : false;
}

/**
 * Extend the scope of the looped template
 * @param   {Object} scope - current template scope
 * @param   {Object} options - options
 * @param   {string} options.itemName - key to identify the looped item in the new context
 * @param   {string} options.indexName - key to identify the index of the looped item
 * @param   {number} options.index - current index
 * @param   {*} options.item - collection item looped
 * @returns {Object} enhanced scope object
 */
function extendScope(scope, _ref) {
  let {
    itemName,
    indexName,
    index,
    item
  } = _ref;
  (0,_util_objects_js__WEBPACK_IMPORTED_MODULE_3__.defineProperty)(scope, itemName, item);
  if (indexName) (0,_util_objects_js__WEBPACK_IMPORTED_MODULE_3__.defineProperty)(scope, indexName, index);
  return scope;
}

/**
 * Loop the current template items
 * @param   {Array} items - expression collection value
 * @param   {*} scope - template scope
 * @param   {*} parentScope - scope of the parent template
 * @param   {EachBinding} binding - each binding object instance
 * @returns {Object} data
 * @returns {Map} data.newChildrenMap - a Map containing the new children template structure
 * @returns {Array} data.batches - array containing the template lifecycle functions to trigger
 * @returns {Array} data.futureNodes - array containing the nodes we need to diff
 */
function createPatch(items, scope, parentScope, binding) {
  const {
    condition,
    template,
    childrenMap,
    itemName,
    getKey,
    indexName,
    root,
    isTemplateTag
  } = binding;
  const newChildrenMap = new Map();
  const batches = [];
  const futureNodes = [];
  items.forEach((item, index) => {
    const context = extendScope(Object.create(scope), {
      itemName,
      indexName,
      index,
      item
    });
    const key = getKey ? getKey(context) : index;
    const oldItem = childrenMap.get(key);
    const nodes = [];
    if (mustFilterItem(condition, context)) {
      return;
    }
    const mustMount = !oldItem;
    const componentTemplate = oldItem ? oldItem.template : template.clone();
    const el = componentTemplate.el || root.cloneNode();
    const meta = isTemplateTag && mustMount ? createTemplateMeta(componentTemplate) : componentTemplate.meta;
    if (mustMount) {
      batches.push(() => componentTemplate.mount(el, context, parentScope, meta));
    } else {
      batches.push(() => componentTemplate.update(context, parentScope));
    }

    // create the collection of nodes to update or to add
    // in case of template tags we need to add all its children nodes
    if (isTemplateTag) {
      nodes.push(...meta.children);
    } else {
      nodes.push(el);
    }

    // delete the old item from the children map
    childrenMap.delete(key);
    futureNodes.push(...nodes);

    // update the children map
    newChildrenMap.set(key, {
      nodes,
      template: componentTemplate,
      context,
      index
    });
  });
  return {
    newChildrenMap,
    batches,
    futureNodes
  };
}
function create$6(node, _ref2) {
  let {
    evaluate,
    condition,
    itemName,
    indexName,
    getKey,
    template
  } = _ref2;
  const placeholder = document.createTextNode('');
  const root = node.cloneNode();
  (0,_util_dom_js__WEBPACK_IMPORTED_MODULE_2__.insertBefore)(placeholder, node);
  (0,_util_dom_js__WEBPACK_IMPORTED_MODULE_2__.removeChild)(node);
  return Object.assign({}, EachBinding, {
    childrenMap: new Map(),
    node,
    root,
    condition,
    evaluate,
    isTemplateTag: (0,_util_checks_js__WEBPACK_IMPORTED_MODULE_4__.isTemplate)(root),
    template: template.createDOM(node),
    getKey,
    indexName,
    itemName,
    placeholder
  });
}

/**
 * Binding responsible for the `if` directive
 */
const IfBinding = {
  // dynamic binding properties
  // node: null,
  // evaluate: null,
  // isTemplateTag: false,
  // placeholder: null,
  // template: null,

  // API methods
  mount(scope, parentScope) {
    return this.update(scope, parentScope);
  },
  update(scope, parentScope) {
    const value = !!this.evaluate(scope);
    const mustMount = !this.value && value;
    const mustUnmount = this.value && !value;
    const mount = () => {
      const pristine = this.node.cloneNode();
      (0,_util_dom_js__WEBPACK_IMPORTED_MODULE_2__.insertBefore)(pristine, this.placeholder);
      this.template = this.template.clone();
      this.template.mount(pristine, scope, parentScope);
    };
    switch (true) {
      case mustMount:
        mount();
        break;
      case mustUnmount:
        this.unmount(scope);
        break;
      default:
        if (value) this.template.update(scope, parentScope);
    }
    this.value = value;
    return this;
  },
  unmount(scope, parentScope) {
    this.template.unmount(scope, parentScope, true);
    return this;
  }
};
function create$5(node, _ref3) {
  let {
    evaluate,
    template
  } = _ref3;
  const placeholder = document.createTextNode('');
  (0,_util_dom_js__WEBPACK_IMPORTED_MODULE_2__.insertBefore)(placeholder, node);
  (0,_util_dom_js__WEBPACK_IMPORTED_MODULE_2__.removeChild)(node);
  return Object.assign({}, IfBinding, {
    node,
    evaluate,
    placeholder,
    template: template.createDOM(node)
  });
}
const ElementProto = typeof Element === 'undefined' ? {} : Element.prototype;
const isNativeHtmlProperty = (0,_util_misc_js__WEBPACK_IMPORTED_MODULE_5__.memoize)(name => ElementProto.hasOwnProperty(name)); // eslint-disable-line

/**
 * Add all the attributes provided
 * @param   {HTMLElement} node - target node
 * @param   {Object} attributes - object containing the attributes names and values
 * @returns {undefined} sorry it's a void function :(
 */
function setAllAttributes(node, attributes) {
  Object.entries(attributes).forEach(_ref4 => {
    let [name, value] = _ref4;
    return attributeExpression(node, {
      name
    }, value);
  });
}

/**
 * Remove all the attributes provided
 * @param   {HTMLElement} node - target node
 * @param   {Object} newAttributes - object containing all the new attribute names
 * @param   {Object} oldAttributes - object containing all the old attribute names
 * @returns {undefined} sorry it's a void function :(
 */
function removeAllAttributes(node, newAttributes, oldAttributes) {
  const newKeys = newAttributes ? Object.keys(newAttributes) : [];
  Object.keys(oldAttributes).filter(name => !newKeys.includes(name)).forEach(attribute => node.removeAttribute(attribute));
}

/**
 * Check whether the attribute value can be rendered
 * @param {*} value - expression value
 * @returns {boolean} true if we can render this attribute value
 */
function canRenderAttribute(value) {
  return value === true || ['string', 'number'].includes(typeof value);
}

/**
 * Check whether the attribute should be removed
 * @param {*} value - expression value
 * @returns {boolean} boolean - true if the attribute can be removed}
 */
function shouldRemoveAttribute(value) {
  return !value && value !== 0;
}

/**
 * This methods handles the DOM attributes updates
 * @param   {HTMLElement} node - target node
 * @param   {Object} expression - expression object
 * @param   {string} expression.name - attribute name
 * @param   {*} value - new expression value
 * @param   {*} oldValue - the old expression cached value
 * @returns {undefined}
 */
function attributeExpression(node, _ref5, value, oldValue) {
  let {
    name
  } = _ref5;
  // is it a spread operator? {...attributes}
  if (!name) {
    if (oldValue) {
      // remove all the old attributes
      removeAllAttributes(node, value, oldValue);
    }

    // is the value still truthy?
    if (value) {
      setAllAttributes(node, value);
    }
    return;
  }

  // handle boolean attributes
  if (!isNativeHtmlProperty(name) && ((0,_util_checks_js__WEBPACK_IMPORTED_MODULE_4__.isBoolean)(value) || (0,_util_checks_js__WEBPACK_IMPORTED_MODULE_4__.isObject)(value) || (0,_util_checks_js__WEBPACK_IMPORTED_MODULE_4__.isFunction)(value))) {
    node[name] = value;
  }
  if (shouldRemoveAttribute(value)) {
    node.removeAttribute(name);
  } else if (canRenderAttribute(value)) {
    node.setAttribute(name, normalizeValue(name, value));
  }
}

/**
 * Get the value as string
 * @param   {string} name - attribute name
 * @param   {*} value - user input value
 * @returns {string} input value as string
 */
function normalizeValue(name, value) {
  // be sure that expressions like selected={ true } will be always rendered as selected='selected'
  return value === true ? name : value;
}
const RE_EVENTS_PREFIX = /^on/;
const getCallbackAndOptions = value => Array.isArray(value) ? value : [value, false];

// see also https://medium.com/@WebReflection/dom-handleevent-a-cross-platform-standard-since-year-2000-5bf17287fd38
const EventListener = {
  handleEvent(event) {
    this[event.type](event);
  }
};
const ListenersWeakMap = new WeakMap();
const createListener = node => {
  const listener = Object.create(EventListener);
  ListenersWeakMap.set(node, listener);
  return listener;
};

/**
 * Set a new event listener
 * @param   {HTMLElement} node - target node
 * @param   {Object} expression - expression object
 * @param   {string} expression.name - event name
 * @param   {*} value - new expression value
 * @returns {value} the callback just received
 */
function eventExpression(node, _ref6, value) {
  let {
    name
  } = _ref6;
  const normalizedEventName = name.replace(RE_EVENTS_PREFIX, '');
  const eventListener = ListenersWeakMap.get(node) || createListener(node);
  const [callback, options] = getCallbackAndOptions(value);
  const handler = eventListener[normalizedEventName];
  const mustRemoveEvent = handler && !callback;
  const mustAddEvent = callback && !handler;
  if (mustRemoveEvent) {
    node.removeEventListener(normalizedEventName, eventListener);
  }
  if (mustAddEvent) {
    node.addEventListener(normalizedEventName, eventListener, options);
  }
  eventListener[normalizedEventName] = callback;
}

/**
 * Normalize the user value in order to render a empty string in case of falsy values
 * @param   {*} value - user input value
 * @returns {string} hopefully a string
 */
function normalizeStringValue(value) {
  return (0,_util_checks_js__WEBPACK_IMPORTED_MODULE_4__.isNil)(value) ? '' : value;
}

/**
 * Get the the target text node to update or create one from of a comment node
 * @param   {HTMLElement} node - any html element containing childNodes
 * @param   {number} childNodeIndex - index of the text node in the childNodes list
 * @returns {Text} the text node to update
 */
const getTextNode = (node, childNodeIndex) => {
  const target = node.childNodes[childNodeIndex];
  if (target.nodeType === Node.COMMENT_NODE) {
    const textNode = document.createTextNode('');
    node.replaceChild(textNode, target);
    return textNode;
  }
  return target;
};

/**
 * This methods handles a simple text expression update
 * @param   {HTMLElement} node - target node
 * @param   {Object} data - expression object
 * @param   {*} value - new expression value
 * @returns {undefined}
 */
function textExpression(node, data, value) {
  node.data = normalizeStringValue(value);
}

/**
 * This methods handles the input fileds value updates
 * @param   {HTMLElement} node - target node
 * @param   {Object} expression - expression object
 * @param   {*} value - new expression value
 * @returns {undefined}
 */
function valueExpression(node, expression, value) {
  node.value = normalizeStringValue(value);
}
const expressions = {
  [_util_expression_types_js__WEBPACK_IMPORTED_MODULE_1__.ATTRIBUTE]: attributeExpression,
  [_util_expression_types_js__WEBPACK_IMPORTED_MODULE_1__.EVENT]: eventExpression,
  [_util_expression_types_js__WEBPACK_IMPORTED_MODULE_1__.TEXT]: textExpression,
  [_util_expression_types_js__WEBPACK_IMPORTED_MODULE_1__.VALUE]: valueExpression
};
const Expression = {
  // Static props
  // node: null,
  // value: null,

  // API methods
  /**
   * Mount the expression evaluating its initial value
   * @param   {*} scope - argument passed to the expression to evaluate its current values
   * @returns {Expression} self
   */
  mount(scope) {
    // hopefully a pure function
    this.value = this.evaluate(scope);

    // IO() DOM updates
    apply(this, this.value);
    return this;
  },
  /**
   * Update the expression if its value changed
   * @param   {*} scope - argument passed to the expression to evaluate its current values
   * @returns {Expression} self
   */
  update(scope) {
    // pure function
    const value = this.evaluate(scope);
    if (this.value !== value) {
      // IO() DOM updates
      apply(this, value);
      this.value = value;
    }
    return this;
  },
  /**
   * Expression teardown method
   * @returns {Expression} self
   */
  unmount() {
    // unmount only the event handling expressions
    if (this.type === _util_expression_types_js__WEBPACK_IMPORTED_MODULE_1__.EVENT) apply(this, null);
    return this;
  }
};

/**
 * IO() function to handle the DOM updates
 * @param {Expression} expression - expression object
 * @param {*} value - current expression value
 * @returns {undefined}
 */
function apply(expression, value) {
  return expressions[expression.type](expression.node, expression, value, expression.value);
}
function create$4(node, data) {
  return Object.assign({}, Expression, data, {
    node: data.type === _util_expression_types_js__WEBPACK_IMPORTED_MODULE_1__.TEXT ? getTextNode(node, data.childNodeIndex) : node
  });
}

/**
 * Create a flat object having as keys a list of methods that if dispatched will propagate
 * on the whole collection
 * @param   {Array} collection - collection to iterate
 * @param   {Array<string>} methods - methods to execute on each item of the collection
 * @param   {*} context - context returned by the new methods created
 * @returns {Object} a new object to simplify the the nested methods dispatching
 */
function flattenCollectionMethods(collection, methods, context) {
  return methods.reduce((acc, method) => {
    return Object.assign({}, acc, {
      [method]: scope => {
        return collection.map(item => item[method](scope)) && context;
      }
    });
  }, {});
}
function create$3(node, _ref7) {
  let {
    expressions
  } = _ref7;
  return Object.assign({}, flattenCollectionMethods(expressions.map(expression => create$4(node, expression)), ['mount', 'update', 'unmount']));
}
function extendParentScope(attributes, scope, parentScope) {
  if (!attributes || !attributes.length) return parentScope;
  const expressions = attributes.map(attr => Object.assign({}, attr, {
    value: attr.evaluate(scope)
  }));
  return Object.assign(Object.create(parentScope || null), (0,_util_misc_js__WEBPACK_IMPORTED_MODULE_5__.evaluateAttributeExpressions)(expressions));
}

// this function is only meant to fix an edge case
// https://github.com/riot/riot/issues/2842
const getRealParent = (scope, parentScope) => scope[_util_constants_js__WEBPACK_IMPORTED_MODULE_6__.PARENT_KEY_SYMBOL] || parentScope;
const SlotBinding = {
  // dynamic binding properties
  // node: null,
  // name: null,
  attributes: [],
  // template: null,

  getTemplateScope(scope, parentScope) {
    return extendParentScope(this.attributes, scope, parentScope);
  },
  // API methods
  mount(scope, parentScope) {
    const templateData = scope.slots ? scope.slots.find(_ref8 => {
      let {
        id
      } = _ref8;
      return id === this.name;
    }) : false;
    const {
      parentNode
    } = this.node;
    const realParent = getRealParent(scope, parentScope);
    this.template = templateData && create(templateData.html, templateData.bindings).createDOM(parentNode);
    if (this.template) {
      (0,_util_dom_js__WEBPACK_IMPORTED_MODULE_2__.cleanNode)(this.node);
      this.template.mount(this.node, this.getTemplateScope(scope, realParent), realParent);
      this.template.children = Array.from(this.node.childNodes);
    }
    moveSlotInnerContent(this.node);
    (0,_util_dom_js__WEBPACK_IMPORTED_MODULE_2__.removeChild)(this.node);
    return this;
  },
  update(scope, parentScope) {
    if (this.template) {
      const realParent = getRealParent(scope, parentScope);
      this.template.update(this.getTemplateScope(scope, realParent), realParent);
    }
    return this;
  },
  unmount(scope, parentScope, mustRemoveRoot) {
    if (this.template) {
      this.template.unmount(this.getTemplateScope(scope, parentScope), null, mustRemoveRoot);
    }
    return this;
  }
};

/**
 * Move the inner content of the slots outside of them
 * @param   {HTMLElement} slot - slot node
 * @returns {undefined} it's a void method ¯\_(ツ)_/¯
 */
function moveSlotInnerContent(slot) {
  const child = slot && slot.firstChild;
  if (!child) return;
  (0,_util_dom_js__WEBPACK_IMPORTED_MODULE_2__.insertBefore)(child, slot);
  moveSlotInnerContent(slot);
}

/**
 * Create a single slot binding
 * @param   {HTMLElement} node - slot node
 * @param   {string} name - slot id
 * @param   {AttributeExpressionData[]} attributes - slot attributes
 * @returns {Object} Slot binding object
 */
function createSlot(node, _ref9) {
  let {
    name,
    attributes
  } = _ref9;
  return Object.assign({}, SlotBinding, {
    attributes,
    node,
    name
  });
}

/**
 * Create a new tag object if it was registered before, otherwise fallback to the simple
 * template chunk
 * @param   {Function} component - component factory function
 * @param   {Array<Object>} slots - array containing the slots markup
 * @param   {Array} attributes - dynamic attributes that will be received by the tag element
 * @returns {TagImplementation|TemplateChunk} a tag implementation or a template chunk as fallback
 */
function getTag(component, slots, attributes) {
  if (slots === void 0) {
    slots = [];
  }
  if (attributes === void 0) {
    attributes = [];
  }
  // if this tag was registered before we will return its implementation
  if (component) {
    return component({
      slots,
      attributes
    });
  }

  // otherwise we return a template chunk
  return create(slotsToMarkup(slots), [...slotBindings(slots), {
    // the attributes should be registered as binding
    // if we fallback to a normal template chunk
    expressions: attributes.map(attr => {
      return Object.assign({
        type: _util_expression_types_js__WEBPACK_IMPORTED_MODULE_1__.ATTRIBUTE
      }, attr);
    })
  }]);
}

/**
 * Merge all the slots bindings into a single array
 * @param   {Array<Object>} slots - slots collection
 * @returns {Array<Bindings>} flatten bindings array
 */
function slotBindings(slots) {
  return slots.reduce((acc, _ref10) => {
    let {
      bindings
    } = _ref10;
    return acc.concat(bindings);
  }, []);
}

/**
 * Merge all the slots together in a single markup string
 * @param   {Array<Object>} slots - slots collection
 * @returns {string} markup of all the slots in a single string
 */
function slotsToMarkup(slots) {
  return slots.reduce((acc, slot) => {
    return acc + slot.html;
  }, '');
}
const TagBinding = {
  // dynamic binding properties
  // node: null,
  // evaluate: null,
  // name: null,
  // slots: null,
  // tag: null,
  // attributes: null,
  // getComponent: null,

  mount(scope) {
    return this.update(scope);
  },
  update(scope, parentScope) {
    const name = this.evaluate(scope);

    // simple update
    if (name && name === this.name) {
      this.tag.update(scope);
    } else {
      // unmount the old tag if it exists
      this.unmount(scope, parentScope, true);

      // mount the new tag
      this.name = name;
      this.tag = getTag(this.getComponent(name), this.slots, this.attributes);
      this.tag.mount(this.node, scope);
    }
    return this;
  },
  unmount(scope, parentScope, keepRootTag) {
    if (this.tag) {
      // keep the root tag
      this.tag.unmount(keepRootTag);
    }
    return this;
  }
};
function create$2(node, _ref11) {
  let {
    evaluate,
    getComponent,
    slots,
    attributes
  } = _ref11;
  return Object.assign({}, TagBinding, {
    node,
    evaluate,
    slots,
    attributes,
    getComponent
  });
}
const bindings = {
  [_util_binding_types_js__WEBPACK_IMPORTED_MODULE_0__.IF]: create$5,
  [_util_binding_types_js__WEBPACK_IMPORTED_MODULE_0__.SIMPLE]: create$3,
  [_util_binding_types_js__WEBPACK_IMPORTED_MODULE_0__.EACH]: create$6,
  [_util_binding_types_js__WEBPACK_IMPORTED_MODULE_0__.TAG]: create$2,
  [_util_binding_types_js__WEBPACK_IMPORTED_MODULE_0__.SLOT]: createSlot
};

/**
 * Text expressions in a template tag will get childNodeIndex value normalized
 * depending on the position of the <template> tag offset
 * @param   {Expression[]} expressions - riot expressions array
 * @param   {number} textExpressionsOffset - offset of the <template> tag
 * @returns {Expression[]} expressions containing the text expressions normalized
 */
function fixTextExpressionsOffset(expressions, textExpressionsOffset) {
  return expressions.map(e => e.type === _util_expression_types_js__WEBPACK_IMPORTED_MODULE_1__.TEXT ? Object.assign({}, e, {
    childNodeIndex: e.childNodeIndex + textExpressionsOffset
  }) : e);
}

/**
 * Bind a new expression object to a DOM node
 * @param   {HTMLElement} root - DOM node where to bind the expression
 * @param   {TagBindingData} binding - binding data
 * @param   {number|null} templateTagOffset - if it's defined we need to fix the text expressions childNodeIndex offset
 * @returns {Binding} Binding object
 */
function create$1(root, binding, templateTagOffset) {
  const {
    selector,
    type,
    redundantAttribute,
    expressions
  } = binding;
  // find the node to apply the bindings
  const node = selector ? root.querySelector(selector) : root;

  // remove eventually additional attributes created only to select this node
  if (redundantAttribute) node.removeAttribute(redundantAttribute);
  const bindingExpressions = expressions || [];

  // init the binding
  return (bindings[type] || bindings[_util_binding_types_js__WEBPACK_IMPORTED_MODULE_0__.SIMPLE])(node, Object.assign({}, binding, {
    expressions: templateTagOffset && !selector ? fixTextExpressionsOffset(bindingExpressions, templateTagOffset) : bindingExpressions
  }));
}

// in this case a simple innerHTML is enough
function createHTMLTree(html, root) {
  const template = (0,_util_checks_js__WEBPACK_IMPORTED_MODULE_4__.isTemplate)(root) ? root : document.createElement('template');
  template.innerHTML = html;
  return template.content;
}

// for svg nodes we need a bit more work
function createSVGTree(html, container) {
  // create the SVGNode
  const svgNode = container.ownerDocument.importNode(new window.DOMParser().parseFromString(`<svg xmlns="http://www.w3.org/2000/svg">${html}</svg>`, 'application/xml').documentElement, true);
  return svgNode;
}

/**
 * Create the DOM that will be injected
 * @param {Object} root - DOM node to find out the context where the fragment will be created
 * @param   {string} html - DOM to create as string
 * @returns {HTMLDocumentFragment|HTMLElement} a new html fragment
 */
function createDOMTree(root, html) {
  if ((0,_util_checks_js__WEBPACK_IMPORTED_MODULE_4__.isSvg)(root)) return createSVGTree(html, root);
  return createHTMLTree(html, root);
}

/**
 * Inject the DOM tree into a target node
 * @param   {HTMLElement} el - target element
 * @param   {DocumentFragment|SVGElement} dom - dom tree to inject
 * @returns {undefined}
 */
function injectDOM(el, dom) {
  switch (true) {
    case (0,_util_checks_js__WEBPACK_IMPORTED_MODULE_4__.isSvg)(el):
      (0,_util_dom_js__WEBPACK_IMPORTED_MODULE_2__.moveChildren)(dom, el);
      break;
    case (0,_util_checks_js__WEBPACK_IMPORTED_MODULE_4__.isTemplate)(el):
      el.parentNode.replaceChild(dom, el);
      break;
    default:
      el.appendChild(dom);
  }
}

/**
 * Create the Template DOM skeleton
 * @param   {HTMLElement} el - root node where the DOM will be injected
 * @param   {string|HTMLElement} html - HTML markup or HTMLElement that will be injected into the root node
 * @returns {?DocumentFragment} fragment that will be injected into the root node
 */
function createTemplateDOM(el, html) {
  return html && (typeof html === 'string' ? createDOMTree(el, html) : html);
}

/**
 * Get the offset of the <template> tag
 * @param {HTMLElement} parentNode - template tag parent node
 * @param {HTMLElement} el - the template tag we want to render
 * @param   {Object} meta - meta properties needed to handle the <template> tags in loops
 * @returns {number} offset of the <template> tag calculated from its siblings DOM nodes
 */
function getTemplateTagOffset(parentNode, el, meta) {
  const siblings = Array.from(parentNode.childNodes);
  return Math.max(siblings.indexOf(el), siblings.indexOf(meta.head) + 1, 0);
}

/**
 * Template Chunk model
 * @type {Object}
 */
const TemplateChunk = {
  // Static props
  // bindings: null,
  // bindingsData: null,
  // html: null,
  // isTemplateTag: false,
  // fragment: null,
  // children: null,
  // dom: null,
  // el: null,

  /**
   * Create the template DOM structure that will be cloned on each mount
   * @param   {HTMLElement} el - the root node
   * @returns {TemplateChunk} self
   */
  createDOM(el) {
    // make sure that the DOM gets created before cloning the template
    this.dom = this.dom || createTemplateDOM(el, this.html) || document.createDocumentFragment();
    return this;
  },
  // API methods
  /**
   * Attach the template to a DOM node
   * @param   {HTMLElement} el - target DOM node
   * @param   {*} scope - template data
   * @param   {*} parentScope - scope of the parent template tag
   * @param   {Object} meta - meta properties needed to handle the <template> tags in loops
   * @returns {TemplateChunk} self
   */
  mount(el, scope, parentScope, meta) {
    if (meta === void 0) {
      meta = {};
    }
    if (!el) (0,_util_misc_js__WEBPACK_IMPORTED_MODULE_5__.panic)('Please provide DOM node to mount properly your template');
    if (this.el) this.unmount(scope);

    // <template> tags require a bit more work
    // the template fragment might be already created via meta outside of this call
    const {
      fragment,
      children,
      avoidDOMInjection
    } = meta;
    // <template> bindings of course can not have a root element
    // so we check the parent node to set the query selector bindings
    const {
      parentNode
    } = children ? children[0] : el;
    const isTemplateTag = (0,_util_checks_js__WEBPACK_IMPORTED_MODULE_4__.isTemplate)(el);
    const templateTagOffset = isTemplateTag ? getTemplateTagOffset(parentNode, el, meta) : null;

    // create the DOM if it wasn't created before
    this.createDOM(el);

    // create the DOM of this template cloning the original DOM structure stored in this instance
    // notice that if a documentFragment was passed (via meta) we will use it instead
    const cloneNode = fragment || this.dom.cloneNode(true);

    // store root node
    // notice that for template tags the root note will be the parent tag
    this.el = isTemplateTag ? parentNode : el;

    // create the children array only for the <template> fragments
    this.children = isTemplateTag ? children || Array.from(cloneNode.childNodes) : null;

    // inject the DOM into the el only if a fragment is available
    if (!avoidDOMInjection && cloneNode) injectDOM(el, cloneNode);

    // create the bindings
    this.bindings = this.bindingsData.map(binding => create$1(this.el, binding, templateTagOffset));
    this.bindings.forEach(b => b.mount(scope, parentScope));

    // store the template meta properties
    this.meta = meta;
    return this;
  },
  /**
   * Update the template with fresh data
   * @param   {*} scope - template data
   * @param   {*} parentScope - scope of the parent template tag
   * @returns {TemplateChunk} self
   */
  update(scope, parentScope) {
    this.bindings.forEach(b => b.update(scope, parentScope));
    return this;
  },
  /**
   * Remove the template from the node where it was initially mounted
   * @param   {*} scope - template data
   * @param   {*} parentScope - scope of the parent template tag
   * @param   {boolean|null} mustRemoveRoot - if true remove the root element,
   * if false or undefined clean the root tag content, if null don't touch the DOM
   * @returns {TemplateChunk} self
   */
  unmount(scope, parentScope, mustRemoveRoot) {
    if (mustRemoveRoot === void 0) {
      mustRemoveRoot = false;
    }
    const el = this.el;
    if (!el) {
      return this;
    }
    this.bindings.forEach(b => b.unmount(scope, parentScope, mustRemoveRoot));
    switch (true) {
      // pure components should handle the DOM unmount updates by themselves
      // for mustRemoveRoot === null don't touch the DOM
      case el[_util_constants_js__WEBPACK_IMPORTED_MODULE_6__.IS_PURE_SYMBOL] || mustRemoveRoot === null:
        break;

      // if children are declared, clear them
      // applicable for <template> and <slot/> bindings
      case Array.isArray(this.children):
        (0,_util_dom_js__WEBPACK_IMPORTED_MODULE_2__.clearChildren)(this.children);
        break;

      // clean the node children only
      case !mustRemoveRoot:
        (0,_util_dom_js__WEBPACK_IMPORTED_MODULE_2__.cleanNode)(el);
        break;

      // remove the root node only if the mustRemoveRoot is truly
      case !!mustRemoveRoot:
        (0,_util_dom_js__WEBPACK_IMPORTED_MODULE_2__.removeChild)(el);
        break;
    }
    this.el = null;
    return this;
  },
  /**
   * Clone the template chunk
   * @returns {TemplateChunk} a clone of this object resetting the this.el property
   */
  clone() {
    return Object.assign({}, this, {
      meta: {},
      el: null
    });
  }
};

/**
 * Create a template chunk wiring also the bindings
 * @param   {string|HTMLElement} html - template string
 * @param   {BindingData[]} bindings - bindings collection
 * @returns {TemplateChunk} a new TemplateChunk copy
 */
function create(html, bindings) {
  if (bindings === void 0) {
    bindings = [];
  }
  return Object.assign({}, TemplateChunk, {
    html,
    bindingsData: bindings
  });
}




/***/ }),

/***/ "./node_modules/riot/esm/node_modules/@riotjs/util/binding-types.js":
/*!**************************************************************************!*\
  !*** ./node_modules/riot/esm/node_modules/@riotjs/util/binding-types.js ***!
  \**************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "EACH": () => (/* binding */ EACH),
/* harmony export */   "IF": () => (/* binding */ IF),
/* harmony export */   "SIMPLE": () => (/* binding */ SIMPLE),
/* harmony export */   "SLOT": () => (/* binding */ SLOT),
/* harmony export */   "TAG": () => (/* binding */ TAG),
/* harmony export */   "default": () => (/* binding */ bindingTypes)
/* harmony export */ });
/* Riot WIP, @license MIT */
const EACH = 0;
const IF = 1;
const SIMPLE = 2;
const TAG = 3;
const SLOT = 4;
const bindingTypes = {
  EACH,
  IF,
  SIMPLE,
  TAG,
  SLOT
};




/***/ }),

/***/ "./node_modules/riot/esm/node_modules/@riotjs/util/checks.js":
/*!*******************************************************************!*\
  !*** ./node_modules/riot/esm/node_modules/@riotjs/util/checks.js ***!
  \*******************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "checkType": () => (/* binding */ checkType),
/* harmony export */   "isBoolean": () => (/* binding */ isBoolean),
/* harmony export */   "isFunction": () => (/* binding */ isFunction),
/* harmony export */   "isNil": () => (/* binding */ isNil),
/* harmony export */   "isObject": () => (/* binding */ isObject),
/* harmony export */   "isSvg": () => (/* binding */ isSvg),
/* harmony export */   "isTemplate": () => (/* binding */ isTemplate)
/* harmony export */ });
/* Riot WIP, @license MIT */
/**
 * Quick type checking
 * @param   {*} element - anything
 * @param   {string} type - type definition
 * @returns {boolean} true if the type corresponds
 */
function checkType(element, type) {
  return typeof element === type;
}

/**
 * Check if an element is part of an svg
 * @param   {HTMLElement}  el - element to check
 * @returns {boolean} true if we are in an svg context
 */
function isSvg(el) {
  const owner = el.ownerSVGElement;
  return !!owner || owner === null;
}

/**
 * Check if an element is a template tag
 * @param   {HTMLElement}  el - element to check
 * @returns {boolean} true if it's a <template>
 */
function isTemplate(el) {
  return el.tagName.toLowerCase() === 'template';
}

/**
 * Check that will be passed if its argument is a function
 * @param   {*} value - value to check
 * @returns {boolean} - true if the value is a function
 */
function isFunction(value) {
  return checkType(value, 'function');
}

/**
 * Check if a value is a Boolean
 * @param   {*}  value - anything
 * @returns {boolean} true only for the value is a boolean
 */
function isBoolean(value) {
  return checkType(value, 'boolean');
}

/**
 * Check if a value is an Object
 * @param   {*}  value - anything
 * @returns {boolean} true only for the value is an object
 */
function isObject(value) {
  return !isNil(value) && value.constructor === Object;
}

/**
 * Check if a value is null or undefined
 * @param   {*}  value - anything
 * @returns {boolean} true only for the 'undefined' and 'null' types
 */
function isNil(value) {
  return value === null || value === undefined;
}




/***/ }),

/***/ "./node_modules/riot/esm/node_modules/@riotjs/util/constants.js":
/*!**********************************************************************!*\
  !*** ./node_modules/riot/esm/node_modules/@riotjs/util/constants.js ***!
  \**********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "ATTRIBUTES_KEY_SYMBOL": () => (/* binding */ ATTRIBUTES_KEY_SYMBOL),
/* harmony export */   "COMPONENTS_IMPLEMENTATION_MAP": () => (/* binding */ COMPONENTS_IMPLEMENTATION_MAP),
/* harmony export */   "DOM_COMPONENT_INSTANCE_PROPERTY": () => (/* binding */ DOM_COMPONENT_INSTANCE_PROPERTY),
/* harmony export */   "IS_COMPONENT_UPDATING": () => (/* binding */ IS_COMPONENT_UPDATING),
/* harmony export */   "IS_DIRECTIVE": () => (/* binding */ IS_DIRECTIVE),
/* harmony export */   "IS_PURE_SYMBOL": () => (/* binding */ IS_PURE_SYMBOL),
/* harmony export */   "MOUNT_METHOD_KEY": () => (/* binding */ MOUNT_METHOD_KEY),
/* harmony export */   "ON_BEFORE_MOUNT_KEY": () => (/* binding */ ON_BEFORE_MOUNT_KEY),
/* harmony export */   "ON_BEFORE_UNMOUNT_KEY": () => (/* binding */ ON_BEFORE_UNMOUNT_KEY),
/* harmony export */   "ON_BEFORE_UPDATE_KEY": () => (/* binding */ ON_BEFORE_UPDATE_KEY),
/* harmony export */   "ON_MOUNTED_KEY": () => (/* binding */ ON_MOUNTED_KEY),
/* harmony export */   "ON_UNMOUNTED_KEY": () => (/* binding */ ON_UNMOUNTED_KEY),
/* harmony export */   "ON_UPDATED_KEY": () => (/* binding */ ON_UPDATED_KEY),
/* harmony export */   "PARENT_KEY_SYMBOL": () => (/* binding */ PARENT_KEY_SYMBOL),
/* harmony export */   "PLUGINS_SET": () => (/* binding */ PLUGINS_SET),
/* harmony export */   "PROPS_KEY": () => (/* binding */ PROPS_KEY),
/* harmony export */   "ROOT_KEY": () => (/* binding */ ROOT_KEY),
/* harmony export */   "SHOULD_UPDATE_KEY": () => (/* binding */ SHOULD_UPDATE_KEY),
/* harmony export */   "SLOTS_KEY": () => (/* binding */ SLOTS_KEY),
/* harmony export */   "STATE_KEY": () => (/* binding */ STATE_KEY),
/* harmony export */   "TEMPLATE_KEY_SYMBOL": () => (/* binding */ TEMPLATE_KEY_SYMBOL),
/* harmony export */   "UNMOUNT_METHOD_KEY": () => (/* binding */ UNMOUNT_METHOD_KEY),
/* harmony export */   "UPDATE_METHOD_KEY": () => (/* binding */ UPDATE_METHOD_KEY)
/* harmony export */ });
/* Riot WIP, @license MIT */
// Riot.js constants that can be used across more modules

const COMPONENTS_IMPLEMENTATION_MAP = new Map(),
  DOM_COMPONENT_INSTANCE_PROPERTY = Symbol('riot-component'),
  PLUGINS_SET = new Set(),
  IS_DIRECTIVE = 'is',
  MOUNT_METHOD_KEY = 'mount',
  UPDATE_METHOD_KEY = 'update',
  UNMOUNT_METHOD_KEY = 'unmount',
  SHOULD_UPDATE_KEY = 'shouldUpdate',
  ON_BEFORE_MOUNT_KEY = 'onBeforeMount',
  ON_MOUNTED_KEY = 'onMounted',
  ON_BEFORE_UPDATE_KEY = 'onBeforeUpdate',
  ON_UPDATED_KEY = 'onUpdated',
  ON_BEFORE_UNMOUNT_KEY = 'onBeforeUnmount',
  ON_UNMOUNTED_KEY = 'onUnmounted',
  PROPS_KEY = 'props',
  STATE_KEY = 'state',
  SLOTS_KEY = 'slots',
  ROOT_KEY = 'root',
  IS_PURE_SYMBOL = Symbol('pure'),
  IS_COMPONENT_UPDATING = Symbol('is_updating'),
  PARENT_KEY_SYMBOL = Symbol('parent'),
  ATTRIBUTES_KEY_SYMBOL = Symbol('attributes'),
  TEMPLATE_KEY_SYMBOL = Symbol('template');




/***/ }),

/***/ "./node_modules/riot/esm/node_modules/@riotjs/util/dom.js":
/*!****************************************************************!*\
  !*** ./node_modules/riot/esm/node_modules/@riotjs/util/dom.js ***!
  \****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "DOMattributesToObject": () => (/* binding */ DOMattributesToObject),
/* harmony export */   "cleanNode": () => (/* binding */ cleanNode),
/* harmony export */   "clearChildren": () => (/* binding */ clearChildren),
/* harmony export */   "insertBefore": () => (/* binding */ insertBefore),
/* harmony export */   "moveChildren": () => (/* binding */ moveChildren),
/* harmony export */   "removeChild": () => (/* binding */ removeChild),
/* harmony export */   "replaceChild": () => (/* binding */ replaceChild)
/* harmony export */ });
/* harmony import */ var _strings_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./strings.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/strings.js");
/* Riot WIP, @license MIT */


/**
 * Get all the element attributes as object
 * @param   {HTMLElement} element - DOM node we want to parse
 * @returns {Object} all the attributes found as a key value pairs
 */
function DOMattributesToObject(element) {
  return Array.from(element.attributes).reduce((acc, attribute) => {
    acc[(0,_strings_js__WEBPACK_IMPORTED_MODULE_0__.dashToCamelCase)(attribute.name)] = attribute.value;
    return acc;
  }, {});
}

/**
 * Move all the child nodes from a source tag to another
 * @param   {HTMLElement} source - source node
 * @param   {HTMLElement} target - target node
 * @returns {undefined} it's a void method ¯\_(ツ)_/¯
 */

// Ignore this helper because it's needed only for svg tags
function moveChildren(source, target) {
  // eslint-disable-next-line fp/no-loops
  while (source.firstChild) target.appendChild(source.firstChild);
}

/**
 * Remove the child nodes from any DOM node
 * @param   {HTMLElement} node - target node
 * @returns {undefined}
 */
function cleanNode(node) {
  // eslint-disable-next-line fp/no-loops
  while (node.firstChild) node.removeChild(node.firstChild);
}

/**
 * Clear multiple children in a node
 * @param   {HTMLElement[]} children - direct children nodes
 * @returns {undefined}
 */
function clearChildren(children) {
  // eslint-disable-next-line fp/no-loops,fp/no-let
  for (let i = 0; i < children.length; i++) removeChild(children[i]);
}

/**
 * Remove a node
 * @param {HTMLElement}node - node to remove
 * @returns {undefined}
 */
const removeChild = node => node.remove();

/**
 * Insert before a node
 * @param {HTMLElement} newNode - node to insert
 * @param {HTMLElement} refNode - ref child
 * @returns {undefined}
 */
const insertBefore = (newNode, refNode) => refNode && refNode.parentNode && refNode.parentNode.insertBefore(newNode, refNode);

/**
 * Replace a node
 * @param {HTMLElement} newNode - new node to add to the DOM
 * @param {HTMLElement} replaced - node to replace
 * @returns {undefined}
 */
const replaceChild = (newNode, replaced) => replaced && replaced.parentNode && replaced.parentNode.replaceChild(newNode, replaced);




/***/ }),

/***/ "./node_modules/riot/esm/node_modules/@riotjs/util/expression-types.js":
/*!*****************************************************************************!*\
  !*** ./node_modules/riot/esm/node_modules/@riotjs/util/expression-types.js ***!
  \*****************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "ATTRIBUTE": () => (/* binding */ ATTRIBUTE),
/* harmony export */   "EVENT": () => (/* binding */ EVENT),
/* harmony export */   "TEXT": () => (/* binding */ TEXT),
/* harmony export */   "VALUE": () => (/* binding */ VALUE),
/* harmony export */   "default": () => (/* binding */ expressionTypes)
/* harmony export */ });
/* Riot WIP, @license MIT */
const ATTRIBUTE = 0;
const EVENT = 1;
const TEXT = 2;
const VALUE = 3;
const expressionTypes = {
  ATTRIBUTE,
  EVENT,
  TEXT,
  VALUE
};




/***/ }),

/***/ "./node_modules/riot/esm/node_modules/@riotjs/util/functions.js":
/*!**********************************************************************!*\
  !*** ./node_modules/riot/esm/node_modules/@riotjs/util/functions.js ***!
  \**********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "autobindMethods": () => (/* binding */ autobindMethods),
/* harmony export */   "callOrAssign": () => (/* binding */ callOrAssign),
/* harmony export */   "noop": () => (/* binding */ noop)
/* harmony export */ });
/* harmony import */ var _checks_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./checks.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/checks.js");
/* Riot WIP, @license MIT */


// does simply nothing
function noop() {
  return this;
}

/**
 * Autobind the methods of a source object to itself
 * @param   {Object} source - probably a riot tag instance
 * @param   {Array<string>} methods - list of the methods to autobind
 * @returns {Object} the original object received
 */
function autobindMethods(source, methods) {
  methods.forEach(method => {
    source[method] = source[method].bind(source);
  });
  return source;
}

/**
 * Call the first argument received only if it's a function otherwise return it as it is
 * @param   {*} source - anything
 * @returns {*} anything
 */
function callOrAssign(source) {
  return (0,_checks_js__WEBPACK_IMPORTED_MODULE_0__.isFunction)(source) ? source.prototype && source.prototype.constructor ? new source() : source() : source;
}




/***/ }),

/***/ "./node_modules/riot/esm/node_modules/@riotjs/util/misc.js":
/*!*****************************************************************!*\
  !*** ./node_modules/riot/esm/node_modules/@riotjs/util/misc.js ***!
  \*****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "evaluateAttributeExpressions": () => (/* binding */ evaluateAttributeExpressions),
/* harmony export */   "memoize": () => (/* binding */ memoize),
/* harmony export */   "panic": () => (/* binding */ panic)
/* harmony export */ });
/* harmony import */ var _expression_types_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./expression-types.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/expression-types.js");
/* harmony import */ var _strings_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./strings.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/strings.js");
/* Riot WIP, @license MIT */



/**
 * Throw an error with a descriptive message
 * @param   { string } message - error message
 * @param   { string } cause - optional error cause object
 * @returns { undefined } hoppla... at this point the program should stop working
 */
function panic(message, cause) {
  throw new Error(message, {
    cause
  });
}
/**
 * Returns the memoized (cached) function.
 * // borrowed from https://www.30secondsofcode.org/js/s/memoize
 * @param {Function} fn - function to memoize
 * @returns {Function} memoize function
 */
function memoize(fn) {
  const cache = new Map();
  const cached = val => {
    return cache.has(val) ? cache.get(val) : cache.set(val, fn.call(this, val)) && cache.get(val);
  };
  cached.cache = cache;
  return cached;
}

/**
 * Evaluate a list of attribute expressions
 * @param   {Array} attributes - attribute expressions generated by the riot compiler
 * @returns {Object} key value pairs with the result of the computation
 */
function evaluateAttributeExpressions(attributes) {
  return attributes.reduce((acc, attribute) => {
    const {
      value,
      type
    } = attribute;
    switch (true) {
      // spread attribute
      case !attribute.name && type === _expression_types_js__WEBPACK_IMPORTED_MODULE_0__.ATTRIBUTE:
        return Object.assign({}, acc, value);
      // value attribute
      case type === _expression_types_js__WEBPACK_IMPORTED_MODULE_0__.VALUE:
        acc.value = attribute.value;
        break;
      // normal attributes
      default:
        acc[(0,_strings_js__WEBPACK_IMPORTED_MODULE_1__.dashToCamelCase)(attribute.name)] = attribute.value;
    }
    return acc;
  }, {});
}




/***/ }),

/***/ "./node_modules/riot/esm/node_modules/@riotjs/util/objects.js":
/*!********************************************************************!*\
  !*** ./node_modules/riot/esm/node_modules/@riotjs/util/objects.js ***!
  \********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "defineDefaults": () => (/* binding */ defineDefaults),
/* harmony export */   "defineProperties": () => (/* binding */ defineProperties),
/* harmony export */   "defineProperty": () => (/* binding */ defineProperty)
/* harmony export */ });
/* Riot WIP, @license MIT */
/**
 * Helper function to set an immutable property
 * @param   {Object} source - object where the new property will be set
 * @param   {string} key - object key where the new property will be stored
 * @param   {*} value - value of the new property
 * @param   {Object} options - set the property overriding the default options
 * @returns {Object} - the original object modified
 */
function defineProperty(source, key, value, options) {
  if (options === void 0) {
    options = {};
  }
  /* eslint-disable fp/no-mutating-methods */
  Object.defineProperty(source, key, Object.assign({
    value,
    enumerable: false,
    writable: false,
    configurable: true
  }, options));
  /* eslint-enable fp/no-mutating-methods */

  return source;
}

/**
 * Define multiple properties on a target object
 * @param   {Object} source - object where the new properties will be set
 * @param   {Object} properties - object containing as key pair the key + value properties
 * @param   {Object} options - set the property overriding the default options
 * @returns {Object} the original object modified
 */
function defineProperties(source, properties, options) {
  Object.entries(properties).forEach(_ref => {
    let [key, value] = _ref;
    defineProperty(source, key, value, options);
  });
  return source;
}

/**
 * Define default properties if they don't exist on the source object
 * @param   {Object} source - object that will receive the default properties
 * @param   {Object} defaults - object containing additional optional keys
 * @returns {Object} the original object received enhanced
 */
function defineDefaults(source, defaults) {
  Object.entries(defaults).forEach(_ref2 => {
    let [key, value] = _ref2;
    if (!source[key]) source[key] = value;
  });
  return source;
}




/***/ }),

/***/ "./node_modules/riot/esm/node_modules/@riotjs/util/strings.js":
/*!********************************************************************!*\
  !*** ./node_modules/riot/esm/node_modules/@riotjs/util/strings.js ***!
  \********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "camelToDashCase": () => (/* binding */ camelToDashCase),
/* harmony export */   "dashToCamelCase": () => (/* binding */ dashToCamelCase)
/* harmony export */ });
/* Riot WIP, @license MIT */
/**
 * Convert a string from camel case to dash-case
 * @param   {string} string - probably a component tag name
 * @returns {string} component name normalized
 */
function camelToDashCase(string) {
  return string.replace(/([a-z])([A-Z])/g, '$1-$2').toLowerCase();
}

/**
 * Convert a string containing dashes to camel case
 * @param   {string} string - input string
 * @returns {string} my-string -> myString
 */
function dashToCamelCase(string) {
  return string.replace(/-(\w)/g, (_, c) => c.toUpperCase());
}




/***/ }),

/***/ "./node_modules/riot/esm/node_modules/bianco.attr/index.next.js":
/*!**********************************************************************!*\
  !*** ./node_modules/riot/esm/node_modules/bianco.attr/index.next.js ***!
  \**********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "get": () => (/* binding */ get),
/* harmony export */   "set": () => (/* binding */ set)
/* harmony export */ });
/* harmony import */ var _bianco_dom_to_array_index_next_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../bianco.dom-to-array/index.next.js */ "./node_modules/riot/esm/node_modules/bianco.dom-to-array/index.next.js");
/* Riot WIP, @license MIT */


/**
 * Normalize the return values, in case of a single value we avoid to return an array
 * @param   { Array } values - list of values we want to return
 * @returns { Array|string|boolean } either the whole list of values or the single one found
 * @private
 */
const normalize = values => values.length === 1 ? values[0] : values;

/**
 * Parse all the nodes received to get/remove/check their attributes
 * @param   { HTMLElement|NodeList|Array } els    - DOM node/s to parse
 * @param   { string|Array }               name   - name or list of attributes
 * @param   { string }                     method - method that will be used to parse the attributes
 * @returns { Array|string } result of the parsing in a list or a single value
 * @private
 */
function parseNodes(els, name, method) {
  const names = typeof name === 'string' ? [name] : name;
  return normalize((0,_bianco_dom_to_array_index_next_js__WEBPACK_IMPORTED_MODULE_0__["default"])(els).map(el => {
    return normalize(names.map(n => el[method](n)));
  }));
}

/**
 * Set any attribute on a single or a list of DOM nodes
 * @param   { HTMLElement|NodeList|Array } els   - DOM node/s to parse
 * @param   { string|Object }              name  - either the name of the attribute to set
 *                                                 or a list of properties as object key - value
 * @param   { string }                     value - the new value of the attribute (optional)
 * @returns { HTMLElement|NodeList|Array } the original array of elements passed to this function
 *
 * @example
 *
 * import { set } from 'bianco.attr'
 *
 * const img = document.createElement('img')
 *
 * set(img, 'width', 100)
 *
 * // or also
 * set(img, {
 *   width: 300,
 *   height: 300
 * })
 *
 */
function set(els, name, value) {
  const attrs = typeof name === 'object' ? name : {
    [name]: value
  };
  const props = Object.keys(attrs);
  (0,_bianco_dom_to_array_index_next_js__WEBPACK_IMPORTED_MODULE_0__["default"])(els).forEach(el => {
    props.forEach(prop => el.setAttribute(prop, attrs[prop]));
  });
  return els;
}

/**
 * Get any attribute from a single or a list of DOM nodes
 * @param   { HTMLElement|NodeList|Array } els   - DOM node/s to parse
 * @param   { string|Array }               name  - name or list of attributes to get
 * @returns { Array|string } list of the attributes found
 *
 * @example
 *
 * import { get } from 'bianco.attr'
 *
 * const img = document.createElement('img')
 *
 * get(img, 'width') // => '200'
 *
 * // or also
 * get(img, ['width', 'height']) // => ['200', '300']
 *
 * // or also
 * get([img1, img2], ['width', 'height']) // => [['200', '300'], ['500', '200']]
 */
function get(els, name) {
  return parseNodes(els, name, 'getAttribute');
}




/***/ }),

/***/ "./node_modules/riot/esm/node_modules/bianco.dom-to-array/index.next.js":
/*!******************************************************************************!*\
  !*** ./node_modules/riot/esm/node_modules/bianco.dom-to-array/index.next.js ***!
  \******************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ domToArray)
/* harmony export */ });
/* Riot WIP, @license MIT */
/**
 * Converts any DOM node/s to a loopable array
 * @param   { HTMLElement|NodeList } els - single html element or a node list
 * @returns { Array } always a loopable object
 */
function domToArray(els) {
  // can this object be already looped?
  if (!Array.isArray(els)) {
    // is it a node list?
    if (/^\[object (HTMLCollection|NodeList|Object)\]$/.test(Object.prototype.toString.call(els)) && typeof els.length === 'number') return Array.from(els);else
      // if it's a single node
      // it will be returned as "array" with one single entry
      return [els];
  }
  // this object could be looped out of the box
  return els;
}




/***/ }),

/***/ "./node_modules/riot/esm/node_modules/bianco.query/index.next.js":
/*!***********************************************************************!*\
  !*** ./node_modules/riot/esm/node_modules/bianco.query/index.next.js ***!
  \***********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ $)
/* harmony export */ });
/* harmony import */ var _bianco_dom_to_array_index_next_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../bianco.dom-to-array/index.next.js */ "./node_modules/riot/esm/node_modules/bianco.dom-to-array/index.next.js");
/* Riot WIP, @license MIT */


/**
 * Simple helper to find DOM nodes returning them as array like loopable object
 * @param   { string|DOMNodeList } selector - either the query or the DOM nodes to arraify
 * @param   { HTMLElement }        scope      - context defining where the query will search for the DOM nodes
 * @returns { Array } DOM nodes found as array
 */
function $(selector, scope) {
  return (0,_bianco_dom_to_array_index_next_js__WEBPACK_IMPORTED_MODULE_0__["default"])(typeof selector === 'string' ? (scope || document).querySelectorAll(selector) : selector);
}




/***/ }),

/***/ "./node_modules/riot/esm/node_modules/cumpa/index.next.js":
/*!****************************************************************!*\
  !*** ./node_modules/riot/esm/node_modules/cumpa/index.next.js ***!
  \****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ compose)
/* harmony export */ });
/* Riot WIP, @license MIT */
/**
 * Similar to compose but performs from left-to-right function composition.<br/>
 * {@link https://30secondsofcode.org/function#composeright see also}
 * @param   {...[function]} fns) - list of unary function
 * @returns {*} result of the computation
 */

/**
 * Performs right-to-left function composition.<br/>
 * Use Array.prototype.reduce() to perform right-to-left function composition.<br/>
 * The last (rightmost) function can accept one or more arguments; the remaining functions must be unary.<br/>
 * {@link https://30secondsofcode.org/function#compose original source code}
 * @param   {...[function]} fns) - list of unary function
 * @returns {*} result of the computation
 */
function compose() {
  for (var _len2 = arguments.length, fns = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    fns[_key2] = arguments[_key2];
  }
  return fns.reduce((f, g) => function () {
    return f(g(...arguments));
  });
}




/***/ }),

/***/ "./node_modules/riot/esm/node_modules/curri/index.next.js":
/*!****************************************************************!*\
  !*** ./node_modules/riot/esm/node_modules/curri/index.next.js ***!
  \****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ curry)
/* harmony export */ });
/* Riot WIP, @license MIT */
/**
 * Function to curry any javascript method
 * @param   {Function}  fn - the target function we want to curry
 * @param   {...[args]} acc - initial arguments
 * @returns {Function|*} it will return a function until the target function
 *                       will receive all of its arguments
 */
function curry(fn) {
  for (var _len = arguments.length, acc = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    acc[_key - 1] = arguments[_key];
  }
  return function () {
    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }
    args = [...acc, ...args];
    return args.length < fn.length ? curry(fn, ...args) : fn(...args);
  };
}




/***/ }),

/***/ "./node_modules/riot/esm/riot.js":
/*!***************************************!*\
  !*** ./node_modules/riot/esm/riot.js ***!
  \***************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "__": () => (/* reexport safe */ _api_js__WEBPACK_IMPORTED_MODULE_10__.__),
/* harmony export */   "component": () => (/* reexport safe */ _api_component_js__WEBPACK_IMPORTED_MODULE_6__.component),
/* harmony export */   "install": () => (/* reexport safe */ _api_install_js__WEBPACK_IMPORTED_MODULE_4__.install),
/* harmony export */   "mount": () => (/* reexport safe */ _api_mount_js__WEBPACK_IMPORTED_MODULE_2__.mount),
/* harmony export */   "pure": () => (/* reexport safe */ _api_pure_js__WEBPACK_IMPORTED_MODULE_7__.pure),
/* harmony export */   "register": () => (/* reexport safe */ _api_register_js__WEBPACK_IMPORTED_MODULE_0__.register),
/* harmony export */   "uninstall": () => (/* reexport safe */ _api_uninstall_js__WEBPACK_IMPORTED_MODULE_5__.uninstall),
/* harmony export */   "unmount": () => (/* reexport safe */ _api_unmount_js__WEBPACK_IMPORTED_MODULE_3__.unmount),
/* harmony export */   "unregister": () => (/* reexport safe */ _api_unregister_js__WEBPACK_IMPORTED_MODULE_1__.unregister),
/* harmony export */   "version": () => (/* reexport safe */ _api_version_js__WEBPACK_IMPORTED_MODULE_9__.version),
/* harmony export */   "withTypes": () => (/* reexport safe */ _api_with_types_js__WEBPACK_IMPORTED_MODULE_8__.withTypes)
/* harmony export */ });
/* harmony import */ var _api_register_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./api/register.js */ "./node_modules/riot/esm/api/register.js");
/* harmony import */ var _api_unregister_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./api/unregister.js */ "./node_modules/riot/esm/api/unregister.js");
/* harmony import */ var _api_mount_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./api/mount.js */ "./node_modules/riot/esm/api/mount.js");
/* harmony import */ var _api_unmount_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./api/unmount.js */ "./node_modules/riot/esm/api/unmount.js");
/* harmony import */ var _api_install_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./api/install.js */ "./node_modules/riot/esm/api/install.js");
/* harmony import */ var _api_uninstall_js__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./api/uninstall.js */ "./node_modules/riot/esm/api/uninstall.js");
/* harmony import */ var _api_component_js__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./api/component.js */ "./node_modules/riot/esm/api/component.js");
/* harmony import */ var _api_pure_js__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./api/pure.js */ "./node_modules/riot/esm/api/pure.js");
/* harmony import */ var _api_with_types_js__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./api/with-types.js */ "./node_modules/riot/esm/api/with-types.js");
/* harmony import */ var _api_version_js__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./api/version.js */ "./node_modules/riot/esm/api/version.js");
/* harmony import */ var _api_js__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./api/__.js */ "./node_modules/riot/esm/api/__.js");
/* Riot v7.1.0, @license MIT */













/***/ }),

/***/ "./node_modules/riot/esm/utils/dom.js":
/*!********************************************!*\
  !*** ./node_modules/riot/esm/utils/dom.js ***!
  \********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "getName": () => (/* binding */ getName)
/* harmony export */ });
/* harmony import */ var _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../node_modules/@riotjs/util/constants.js */ "./node_modules/riot/esm/node_modules/@riotjs/util/constants.js");
/* harmony import */ var _node_modules_bianco_attr_index_next_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../node_modules/bianco.attr/index.next.js */ "./node_modules/riot/esm/node_modules/bianco.attr/index.next.js");
/* Riot v7.1.0, @license MIT */



/**
 * Get the tag name of any DOM node
 * @param   {HTMLElement} element - DOM node we want to inspect
 * @returns {string} name to identify this dom node in riot
 */
function getName(element) {
  return (0,_node_modules_bianco_attr_index_next_js__WEBPACK_IMPORTED_MODULE_0__.get)(element, _node_modules_riotjs_util_constants_js__WEBPACK_IMPORTED_MODULE_1__.IS_DIRECTIVE) || element.tagName.toLowerCase();
}




/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = __webpack_modules__;
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/chunk loaded */
/******/ 	(() => {
/******/ 		var deferred = [];
/******/ 		__webpack_require__.O = (result, chunkIds, fn, priority) => {
/******/ 			if(chunkIds) {
/******/ 				priority = priority || 0;
/******/ 				for(var i = deferred.length; i > 0 && deferred[i - 1][2] > priority; i--) deferred[i] = deferred[i - 1];
/******/ 				deferred[i] = [chunkIds, fn, priority];
/******/ 				return;
/******/ 			}
/******/ 			var notFulfilled = Infinity;
/******/ 			for (var i = 0; i < deferred.length; i++) {
/******/ 				var [chunkIds, fn, priority] = deferred[i];
/******/ 				var fulfilled = true;
/******/ 				for (var j = 0; j < chunkIds.length; j++) {
/******/ 					if ((priority & 1 === 0 || notFulfilled >= priority) && Object.keys(__webpack_require__.O).every((key) => (__webpack_require__.O[key](chunkIds[j])))) {
/******/ 						chunkIds.splice(j--, 1);
/******/ 					} else {
/******/ 						fulfilled = false;
/******/ 						if(priority < notFulfilled) notFulfilled = priority;
/******/ 					}
/******/ 				}
/******/ 				if(fulfilled) {
/******/ 					deferred.splice(i--, 1)
/******/ 					var r = fn();
/******/ 					if (r !== undefined) result = r;
/******/ 				}
/******/ 			}
/******/ 			return result;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	(() => {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = (module) => {
/******/ 			var getter = module && module.__esModule ?
/******/ 				() => (module['default']) :
/******/ 				() => (module);
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/jsonp chunk loading */
/******/ 	(() => {
/******/ 		// no baseURI
/******/ 		
/******/ 		// object to store loaded and loading chunks
/******/ 		// undefined = chunk not loaded, null = chunk preloaded/prefetched
/******/ 		// [resolve, reject, Promise] = chunk loading, 0 = chunk loaded
/******/ 		var installedChunks = {
/******/ 			"/example": 0,
/******/ 			"example": 0
/******/ 		};
/******/ 		
/******/ 		// no chunk on demand loading
/******/ 		
/******/ 		// no prefetching
/******/ 		
/******/ 		// no preloaded
/******/ 		
/******/ 		// no HMR
/******/ 		
/******/ 		// no HMR manifest
/******/ 		
/******/ 		__webpack_require__.O.j = (chunkId) => (installedChunks[chunkId] === 0);
/******/ 		
/******/ 		// install a JSONP callback for chunk loading
/******/ 		var webpackJsonpCallback = (parentChunkLoadingFunction, data) => {
/******/ 			var [chunkIds, moreModules, runtime] = data;
/******/ 			// add "moreModules" to the modules object,
/******/ 			// then flag all "chunkIds" as loaded and fire callback
/******/ 			var moduleId, chunkId, i = 0;
/******/ 			if(chunkIds.some((id) => (installedChunks[id] !== 0))) {
/******/ 				for(moduleId in moreModules) {
/******/ 					if(__webpack_require__.o(moreModules, moduleId)) {
/******/ 						__webpack_require__.m[moduleId] = moreModules[moduleId];
/******/ 					}
/******/ 				}
/******/ 				if(runtime) var result = runtime(__webpack_require__);
/******/ 			}
/******/ 			if(parentChunkLoadingFunction) parentChunkLoadingFunction(data);
/******/ 			for(;i < chunkIds.length; i++) {
/******/ 				chunkId = chunkIds[i];
/******/ 				if(__webpack_require__.o(installedChunks, chunkId) && installedChunks[chunkId]) {
/******/ 					installedChunks[chunkId][0]();
/******/ 				}
/******/ 				installedChunks[chunkId] = 0;
/******/ 			}
/******/ 			return __webpack_require__.O(result);
/******/ 		}
/******/ 		
/******/ 		var chunkLoadingGlobal = self["webpackChunk_tiny_components_datepicker"] = self["webpackChunk_tiny_components_datepicker"] || [];
/******/ 		chunkLoadingGlobal.forEach(webpackJsonpCallback.bind(null, 0));
/******/ 		chunkLoadingGlobal.push = webpackJsonpCallback.bind(null, chunkLoadingGlobal.push.bind(chunkLoadingGlobal));
/******/ 	})();
/******/ 	
/************************************************************************/
/******/ 	
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	// This entry module depends on other loaded chunks and execution need to be delayed
/******/ 	__webpack_require__.O(undefined, ["example"], () => (__webpack_require__("./src/example.js")))
/******/ 	var __webpack_exports__ = __webpack_require__.O(undefined, ["example"], () => (__webpack_require__("./src/example.scss")))
/******/ 	__webpack_exports__ = __webpack_require__.O(__webpack_exports__);
/******/ 	
/******/ })()
;